diff -u -r xf86-video-ati-6.6.3.orig/configure.ac xf86-video-ati-6.6.3/configure.ac
--- xf86-video-ati-6.6.3.orig/configure.ac	2007-09-13 11:02:37.535507750 +0200
+++ xf86-video-ati-6.6.3/configure.ac	2007-09-13 11:08:15.272615000 +0200
@@ -222,7 +222,7 @@
 AC_SUBST([DRI_CFLAGS])
 AC_SUBST([moduledir])
 
-DRIVER_NAME=ati
+DRIVER_NAME=atiold
 AC_SUBST([DRIVER_NAME])
 
 XORG_MANPAGE_SECTIONS
diff -u -r xf86-video-ati-6.6.3.orig/man/Makefile.am xf86-video-ati-6.6.3/man/Makefile.am
--- xf86-video-ati-6.6.3.orig/man/Makefile.am	2007-09-13 11:02:42.087792250 +0200
+++ xf86-video-ati-6.6.3/man/Makefile.am	2007-09-13 11:08:15.288616000 +0200
@@ -27,11 +27,11 @@
 
 drivermandir = $(DRIVER_MAN_DIR)
 
-driverman_PRE = @DRIVER_NAME@.man r128.man radeon.man
+driverman_PRE = @DRIVER_NAME@.man r128old.man radeonold.man
 
 driverman_DATA = $(driverman_PRE:man=@DRIVER_MAN_SUFFIX@)
 
-EXTRA_DIST = @DRIVER_NAME@.man r128.man radeon.man
+EXTRA_DIST = @DRIVER_NAME@.man r128old.man radeonold.man
 
 CLEANFILES = $(driverman_DATA)
 
diff -u -r xf86-video-ati-6.6.3.orig/src/Makefile.am xf86-video-ati-6.6.3/src/Makefile.am
--- xf86-video-ati-6.6.3.orig/src/Makefile.am	2007-09-13 11:02:38.343558250 +0200
+++ xf86-video-ati-6.6.3/src/Makefile.am	2007-09-13 11:13:36.132667500 +0200
@@ -48,18 +48,18 @@
 
 AM_CFLAGS = @XORG_CFLAGS@ @DRI_CFLAGS@
 
-ati_drv_la_LTLIBRARIES = ati_drv.la
-ati_drv_la_LDFLAGS = -module -avoid-version
-ati_drv_ladir = @moduledir@/drivers
-ati_drv_la_SOURCES = \
+atiold_drv_la_LTLIBRARIES = atiold_drv.la
+atiold_drv_la_LDFLAGS = -module -avoid-version
+atiold_drv_ladir = @moduledir@/drivers
+atiold_drv_la_SOURCES = \
 	ati.c atiadapter.c atibus.c atichip.c atiident.c atioption.c \
 	atiprobe.c atividmem.c atimodule.c $(ATI_CPIO_SOURCES) \
 	radeon_probe.c r128_probe.c
 
-atimisc_drv_la_LTLIBRARIES = atimisc_drv.la
-atimisc_drv_la_LDFLAGS = -module -avoid-version
-atimisc_drv_ladir = @moduledir@/drivers
-atimisc_drv_la_SOURCES = \
+atimiscold_drv_la_LTLIBRARIES = atimiscold_drv.la
+atimiscold_drv_la_LDFLAGS = -module -avoid-version
+atimiscold_drv_ladir = @moduledir@/drivers
+atimiscold_drv_la_SOURCES = \
 	atiaccel.c atiadjust.c atiaudio.c aticlock.c aticonfig.c aticonsole.c \
 	aticursor.c atidac.c atidecoder.c atidsp.c atifillin.c atii2c.c \
 	atilock.c atimach64.c atimach64accel.c atimach64cursor.c \
@@ -68,40 +68,40 @@
 	atixv.c atiload.c atimisc.c $(ATIMISC_DRI_SRCS) $(ATIMISC_DGA_SOURCES) \
 	$(ATIMISC_CPIO_SOURCES) $(ATIMISC_EXA_SOURCES)
 
-r128_drv_la_LTLIBRARIES = r128_drv.la
-r128_drv_la_LDFLAGS = -module -avoid-version
-r128_drv_ladir = @moduledir@/drivers
-r128_drv_la_SOURCES = \
+r128old_drv_la_LTLIBRARIES = r128old_drv.la
+r128old_drv_la_LDFLAGS = -module -avoid-version
+r128old_drv_ladir = @moduledir@/drivers
+r128old_drv_la_SOURCES = \
 	r128_accel.c r128_cursor.c r128_dga.c r128_driver.c \
 	r128_video.c r128_misc.c $(R128_DRI_SRCS)
 
-radeon_drv_la_LTLIBRARIES = radeon_drv.la
-radeon_drv_la_LDFLAGS = -module -avoid-version
-radeon_drv_ladir = @moduledir@/drivers
-radeon_drv_la_SOURCES = \
+radeonold_drv_la_LTLIBRARIES = radeonold_drv.la
+radeonold_drv_la_LDFLAGS = -module -avoid-version
+radeonold_drv_ladir = @moduledir@/drivers
+radeonold_drv_la_SOURCES = \
 	radeon_accel.c radeon_mergedfb.c radeon_cursor.c radeon_dga.c \
 	radeon_driver.c radeon_video.c radeon_bios.c radeon_mm_i2c.c \
 	radeon_vip.c radeon_misc.c $(RADEON_DRI_SRCS) $(RADEON_EXA_SOURCES)
 
-theatre_detect_drv_la_LTLIBRARIES = theatre_detect_drv.la
-theatre_detect_drv_la_LDFLAGS = -module -avoid-version
-theatre_detect_drv_ladir = @moduledir@/multimedia
-theatre_detect_drv_la_SOURCES = \
+theatre_detectold_drv_la_LTLIBRARIES = theatre_detectold_drv.la
+theatre_detectold_drv_la_LDFLAGS = -module -avoid-version
+theatre_detectold_drv_ladir = @moduledir@/multimedia
+theatre_detectold_drv_la_SOURCES = \
 	theatre_detect.c theatre_detect_module.c
 
-theatre_drv_la_LTLIBRARIES = theatre_drv.la
-theatre_drv_la_LDFLAGS = -module -avoid-version
-theatre_drv_ladir = @moduledir@/multimedia
+theatreold_drv_la_LTLIBRARIES = theatreold_drv.la
+theatreold_drv_la_LDFLAGS = -module -avoid-version
+theatreold_drv_ladir = @moduledir@/multimedia
 
-theatre_drv_la_SOURCES = \
+theatreold_drv_la_SOURCES = \
 	theatre.c theatre_module.c
 
-theatre200_drv_la_LTLIBRARIES = theatre200_drv.la
-theatre200_drv_la_LDFLAGS = -module -avoid-version
-theatre200_drv_ladir = @moduledir@/multimedia
-theatre200_drv_la_CFLAGS = \
-	$(AM_CFLAGS) -DMICROC_DIR=\"$(theatre200_drv_ladir)\"
-theatre200_drv_la_SOURCES = \
+theatre200old_drv_la_LTLIBRARIES = theatre200old_drv.la
+theatre200old_drv_la_LDFLAGS = -module -avoid-version
+theatre200old_drv_ladir = @moduledir@/multimedia
+theatre200old_drv_la_CFLAGS = \
+	$(AM_CFLAGS) -DMICROC_DIR=\"$(theatre200old_drv_ladir)\"
+theatre200old_drv_la_SOURCES = \
 	theatre200.c theatre200_module.c
 
 EXTRA_DIST = \
diff -u -r xf86-video-ati-6.6.3.orig/src/atimisc.c xf86-video-ati-6.6.3/src/atimisc.c
--- xf86-video-ati-6.6.3.orig/src/atimisc.c	2007-09-13 11:02:39.171610000 +0200
+++ xf86-video-ati-6.6.3/src/atimisc.c	2007-09-13 11:08:15.416624000 +0200
@@ -38,7 +38,7 @@
 
 static XF86ModuleVersionInfo ATIVersionRec =
 {
-    "atimisc",
+    "atimiscold",
     MODULEVENDORSTRING,
     MODINFOSTRING1,
     MODINFOSTRING2,
@@ -77,7 +77,7 @@
             /* ati & atimisc module versions must match */
             do
             {
-                XF86ModuleData *pModuleData = LoaderSymbol("atiModuleData");
+                XF86ModuleData *pModuleData = LoaderSymbol("atioldModuleData");
 
                 if (pModuleData)
                 {
@@ -151,7 +151,7 @@
 }
 
 /* The following record must be called atimiscModuleData */
-_X_EXPORT XF86ModuleData atimiscModuleData =
+_X_EXPORT XF86ModuleData atimiscoldModuleData =
 {
     &ATIVersionRec,
     ATISetup,
diff -u -r xf86-video-ati-6.6.3.orig/src/atimodule.c xf86-video-ati-6.6.3/src/atimodule.c
--- xf86-video-ati-6.6.3.orig/src/atimodule.c	2007-09-13 11:02:38.547571000 +0200
+++ xf86-video-ati-6.6.3/src/atimodule.c	2007-09-13 11:08:15.440625500 +0200
@@ -124,7 +124,7 @@
 }
 
 /* The following record must be called atiModuleData */
-_X_EXPORT XF86ModuleData atiModuleData =
+_X_EXPORT XF86ModuleData atioldModuleData =
 {
     &ATIVersionRec,
     ATISetup,
diff -u -r xf86-video-ati-6.6.3.orig/src/atiprobe.c xf86-video-ati-6.6.3/src/atiprobe.c
--- xf86-video-ati-6.6.3.orig/src/atiprobe.c	2007-09-13 11:02:38.503568250 +0200
+++ xf86-video-ati-6.6.3/src/atiprobe.c	2007-09-13 11:19:25.478500250 +0200
@@ -2278,10 +2278,10 @@
 
 #ifdef XFree86LOADER
 
-            if (!xf86LoadSubModule(pScreenInfo, "atimisc"))
+            if (!xf86LoadSubModule(pScreenInfo, "atimiscold"))
             {
                 xf86Msg(X_ERROR,
-                    ATI_NAME ":  Failed to load \"atimisc\" module.\n");
+                    ATI_NAME ":  Failed to load \"atimiscold\" module.\n");
                 xf86DeleteScreen(pScreenInfo->scrnIndex, 0);
                 continue;
             }
diff -u -r xf86-video-ati-6.6.3.orig/src/ativersion.h xf86-video-ati-6.6.3/src/ativersion.h
--- xf86-video-ati-6.6.3.orig/src/ativersion.h	2007-09-13 11:02:40.999724250 +0200
+++ xf86-video-ati-6.6.3/src/ativersion.h	2007-09-13 11:08:15.472627500 +0200
@@ -31,8 +31,8 @@
 #undef  ATI_VERSION_STRINGIFY
 #undef  ATI_VERSION_NAME
 
-#define ATI_NAME          "ATI"
-#define ATI_DRIVER_NAME   "ati"
+#define ATI_NAME          "ATIOLD"
+#define ATI_DRIVER_NAME   "atiold"
 
 #ifndef ATI_VERSION_EXTRA
 #define ATI_VERSION_EXTRA ""
diff -u -r xf86-video-ati-6.6.3.orig/src/r128_misc.c xf86-video-ati-6.6.3/src/r128_misc.c
--- xf86-video-ati-6.6.3.orig/src/r128_misc.c	2007-09-13 11:02:39.535632750 +0200
+++ xf86-video-ati-6.6.3/src/r128_misc.c	2007-09-13 11:08:15.500629250 +0200
@@ -81,7 +81,7 @@
 }
 
 /* The following record must be called r128ModuleData */
-_X_EXPORT XF86ModuleData r128ModuleData =
+_X_EXPORT XF86ModuleData r128oldModuleData =
 {
     &R128VersionRec,
     R128Setup,
diff -u -r xf86-video-ati-6.6.3.orig/src/r128_probe.c xf86-video-ati-6.6.3/src/r128_probe.c
--- xf86-video-ati-6.6.3.orig/src/r128_probe.c	2007-09-13 11:02:38.591573750 +0200
+++ xf86-video-ati-6.6.3/src/r128_probe.c	2007-09-13 11:18:41.555755250 +0200
@@ -198,9 +198,9 @@
 
 #ifdef XFree86LOADER
 
-	    if (!xf86LoadSubModule(pScrn, "r128")) {
+	    if (!xf86LoadSubModule(pScrn, "r128old")) {
 		xf86Msg(X_ERROR,
-		    R128_NAME ":  Failed to load \"r128\" module.\n");
+		    R128_NAME ":  Failed to load \"r128old\" module.\n");
 		xf86DeleteScreen(pScrn->scrnIndex, 0);
 		continue;
 	    }
diff -u -r xf86-video-ati-6.6.3.orig/src/r128_version.h xf86-video-ati-6.6.3/src/r128_version.h
--- xf86-video-ati-6.6.3.orig/src/r128_version.h	2007-09-13 11:02:41.599761750 +0200
+++ xf86-video-ati-6.6.3/src/r128_version.h	2007-09-13 11:08:15.524630750 +0200
@@ -34,8 +34,8 @@
 #undef  R128_VERSION_STRINGIFY
 #undef  R128_VERSION_NAME
 
-#define R128_NAME          "R128"
-#define R128_DRIVER_NAME   "r128"
+#define R128_NAME          "R128OLD"
+#define R128_DRIVER_NAME   "r128old"
 
 #define R128_VERSION_MAJOR 4
 #define R128_VERSION_MINOR 1
diff -u -r xf86-video-ati-6.6.3.orig/src/radeon_misc.c xf86-video-ati-6.6.3/src/radeon_misc.c
--- xf86-video-ati-6.6.3.orig/src/radeon_misc.c	2007-09-13 11:02:39.883654500 +0200
+++ xf86-video-ati-6.6.3/src/radeon_misc.c	2007-09-13 11:08:15.552632500 +0200
@@ -80,7 +80,7 @@
 }
 
 /* The following record must be called radeonModuleData */
-_X_EXPORT XF86ModuleData radeonModuleData =
+_X_EXPORT XF86ModuleData radeonoldModuleData =
 {
     &RADEONVersionRec,
     RADEONSetup,
diff -u -r xf86-video-ati-6.6.3.orig/src/radeon_probe.c xf86-video-ati-6.6.3/src/radeon_probe.c
--- xf86-video-ati-6.6.3.orig/src/radeon_probe.c	2007-09-13 11:02:38.575572750 +0200
+++ xf86-video-ati-6.6.3/src/radeon_probe.c	2007-09-13 11:18:05.449498750 +0200
@@ -287,9 +287,9 @@
 					     RADEONPciChipsets, 0, 0, 0,
 					     0, 0))) {
 #ifdef XFree86LOADER
-		if (!xf86LoadSubModule(pScrn, "radeon")) {
+		if (!xf86LoadSubModule(pScrn, "radeonold")) {
 		    xf86Msg(X_ERROR, RADEON_NAME
-			    ":  Failed to load \"radeon\" module.\n");
+			    ":  Failed to load \"radeonold\" module.\n");
 		    xf86DeleteScreen(pScrn->scrnIndex, 0);
 		    continue;
 		}
diff -u -r xf86-video-ati-6.6.3.orig/src/radeon_version.h xf86-video-ati-6.6.3/src/radeon_version.h
--- xf86-video-ati-6.6.3.orig/src/radeon_version.h	2007-09-13 11:02:41.927782250 +0200
+++ xf86-video-ati-6.6.3/src/radeon_version.h	2007-09-13 11:08:15.604635750 +0200
@@ -35,7 +35,7 @@
 #undef  RADEON_VERSION_STRINGIFY
 #undef  RADEON_VERSION_NAME
 
-#define RADEON_NAME          "RADEON"
+#define RADEON_NAME          "RADEONOLD"
 #define RADEON_DRIVER_NAME   "radeon"
 #define R200_DRIVER_NAME     "r200"
 #define R300_DRIVER_NAME     "r300"