>From 3e40df5e26e469502993780bb95de8d917343c09 Mon Sep 17 00:00:00 2001
From: Guillaume GARDET <guillaume.gardet@oliseo.fr>
Date: Thu, 13 Mar 2014 12:08:22 +0100
Subject: [PATCH] Disable Xen on ARM for now since it is currently broken

---
 config/arm64/default   |   32 ++------------------------------
 config/armv7hl/default |   34 ++--------------------------------
 config/armv7hl/exynos  |   32 ++------------------------------
 config/armv7hl/lpae    |   33 ++-------------------------------
 4 files changed, 8 insertions(+), 123 deletions(-)

diff --git a/config/arm64/default b/config/arm64/default
index 1e07463..f7f814c 100644
--- a/config/arm64/default
+++ b/config/arm64/default
@@ -329,8 +329,7 @@ CONFIG_ZBUD=y
 CONFIG_ZSWAP=y
 CONFIG_ZSMALLOC=y
 # CONFIG_PGTABLE_MAPPING is not set
-CONFIG_XEN_DOM0=y
-CONFIG_PARAVIRT_XEN=y
+# CONFIG_PARAVIRT_XEN is not set
 CONFIG_FORCE_MAX_ZONEORDER=14
 
 #
@@ -1156,7 +1155,7 @@ CONFIG_EXTRA_FIRMWARE=""
 CONFIG_FW_LOADER_USER_HELPER=y
 # CONFIG_DEBUG_DRIVER is not set
 # CONFIG_DEBUG_DEVRES is not set
-CONFIG_SYS_HYPERVISOR=y
+# CONFIG_SYS_HYPERVISOR is not set
 # CONFIG_GENERIC_CPU_DEVICES is not set
 CONFIG_REGMAP=y
 CONFIG_REGMAP_MMIO=m
@@ -1324,8 +1323,6 @@ CONFIG_CDROM_PKTCDVD=m
 CONFIG_CDROM_PKTCDVD_BUFFERS=8
 CONFIG_CDROM_PKTCDVD_WCACHE=y
 CONFIG_ATA_OVER_ETH=m
-CONFIG_PARAVIRT_XEN_BLKDEV_FRONTEND=m
-CONFIG_PARAVIRT_XEN_BLKDEV_BACKEND=m
 CONFIG_VIRTIO_BLK=m
 CONFIG_BLK_DEV_RBD=m
 
@@ -1766,8 +1763,6 @@ CONFIG_X25_ASY=m
 CONFIG_IEEE802154_DRIVERS=m
 CONFIG_IEEE802154_FAKEHARD=m
 CONFIG_IEEE802154_FAKELB=m
-CONFIG_PARAVIRT_XEN_NETDEV_FRONTEND=m
-CONFIG_PARAVIRT_XEN_NETDEV_BACKEND=m
 CONFIG_ISDN=y
 CONFIG_ISDN_I4L=m
 CONFIG_ISDN_PPP=y
@@ -2047,7 +2042,6 @@ CONFIG_INPUT_ADXL34X_I2C=m
 CONFIG_INPUT_IMS_PCU=m
 CONFIG_INPUT_CMA3000=m
 # CONFIG_INPUT_CMA3000_I2C is not set
-CONFIG_INPUT_XEN_KBDDEV_FRONTEND=m
 
 #
 # Hardware I/O ports
@@ -2124,9 +2118,6 @@ CONFIG_PRINTER=m
 # CONFIG_LP_CONSOLE is not set
 CONFIG_PPDEV=m
 CONFIG_HVC_DRIVER=y
-CONFIG_HVC_IRQ=y
-CONFIG_HVC_XEN=y
-CONFIG_HVC_XEN_FRONTEND=y
 CONFIG_VIRTIO_CONSOLE=m
 CONFIG_IPMI_HANDLER=m
 CONFIG_IPMI_PANIC_EVENT=y
@@ -2153,7 +2144,6 @@ CONFIG_TCG_TPM=m
 # CONFIG_TCG_TIS_I2C_INFINEON is not set
 # CONFIG_TCG_TIS_I2C_NUVOTON is not set
 # CONFIG_TCG_ST33_I2C is not set
-CONFIG_TCG_XEN=m
 CONFIG_CRASHER=m
 CONFIG_I2C=m
 CONFIG_I2C_BOARDINFO=y
@@ -2481,7 +2471,6 @@ CONFIG_SOFT_WATCHDOG=m
 # CONFIG_DW_WATCHDOG is not set
 CONFIG_KEMPLD_WDT=m
 # CONFIG_MEN_A21_WDT is not set
-CONFIG_XEN_WDT=m
 
 #
 # USB-based Watchdog Cards
@@ -2877,7 +2866,6 @@ CONFIG_FB_TMIO_ACCELL=y
 # CONFIG_FB_UDL is not set
 CONFIG_FB_GOLDFISH=m
 CONFIG_FB_VIRTUAL=m
-CONFIG_XEN_FBDEV_FRONTEND=m
 CONFIG_FB_METRONOME=m
 CONFIG_FB_BROADSHEET=m
 # CONFIG_FB_AUO_K190X is not set
@@ -3469,22 +3457,6 @@ CONFIG_VIRTIO_MMIO=m
 #
 # Microsoft Hyper-V guest support
 #
-
-#
-# Xen driver support
-#
-CONFIG_XEN_BALLOON=y
-CONFIG_XEN_SCRUB_PAGES=y
-CONFIG_XEN_DEV_EVTCHN=m
-CONFIG_PARAVIRT_XEN_BACKEND=y
-CONFIG_XENFS=m
-# CONFIG_XEN_COMPAT_XENFS is not set
-CONFIG_XEN_SYS_HYPERVISOR=y
-CONFIG_XEN_XENBUS_FRONTEND=y
-CONFIG_XEN_GNTDEV=m
-CONFIG_XEN_GRANT_DEV_ALLOC=m
-CONFIG_SWIOTLB_XEN=y
-CONFIG_XEN_PRIVCMD=m
 CONFIG_STAGING=y
 CONFIG_USBIP_CORE=m
 CONFIG_USBIP_VHCI_HCD=m
diff --git a/config/armv7hl/default b/config/armv7hl/default
index 3bc9ff1..0a1da05 100644
--- a/config/armv7hl/default
+++ b/config/armv7hl/default
@@ -593,7 +593,6 @@ CONFIG_CPU_CP15_MMU=y
 #
 # CONFIG_ARM_LPAE is not set
 # CONFIG_ARCH_PHYS_ADDR_T_64BIT is not set
-CONFIG_ARCH_DMA_ADDR_T_64BIT=y
 CONFIG_ARM_THUMB=y
 # CONFIG_ARM_THUMBEE is not set
 CONFIG_ARM_VIRT_EXT=y
@@ -700,7 +699,6 @@ CONFIG_MIGRATION=y
 # CONFIG_PHYS_ADDR_T_64BIT is not set
 CONFIG_ZONE_DMA_FLAG=0
 CONFIG_BOUNCE=y
-CONFIG_MMU_NOTIFIER=y
 CONFIG_KSM=y
 CONFIG_DEFAULT_MMAP_MIN_ADDR=32768
 CONFIG_CROSS_MEMORY_ATTACH=y
@@ -718,8 +716,7 @@ CONFIG_UACCESS_WITH_MEMCPY=y
 CONFIG_SECCOMP=y
 CONFIG_SWIOTLB=y
 CONFIG_IOMMU_HELPER=y
-CONFIG_XEN_DOM0=y
-CONFIG_PARAVIRT_XEN=y
+# CONFIG_PARAVIRT_XEN is not set
 
 #
 # Boot options
@@ -1643,7 +1640,7 @@ CONFIG_EXTRA_FIRMWARE=""
 CONFIG_FW_LOADER_USER_HELPER=y
 # CONFIG_DEBUG_DRIVER is not set
 # CONFIG_DEBUG_DEVRES is not set
-CONFIG_SYS_HYPERVISOR=y
+# CONFIG_SYS_HYPERVISOR is not set
 # CONFIG_GENERIC_CPU_DEVICES is not set
 CONFIG_SOC_BUS=y
 CONFIG_REGMAP=y
@@ -1884,8 +1881,6 @@ CONFIG_CDROM_PKTCDVD_WCACHE=y
 CONFIG_ATA_OVER_ETH=m
 CONFIG_MG_DISK=m
 CONFIG_MG_DISK_RES=0
-CONFIG_PARAVIRT_XEN_BLKDEV_FRONTEND=m
-CONFIG_PARAVIRT_XEN_BLKDEV_BACKEND=m
 CONFIG_VIRTIO_BLK=m
 CONFIG_BLK_DEV_RBD=m
 
@@ -2420,8 +2415,6 @@ CONFIG_IEEE802154_FAKEHARD=m
 CONFIG_IEEE802154_FAKELB=m
 # CONFIG_IEEE802154_AT86RF230 is not set
 # CONFIG_IEEE802154_MRF24J40 is not set
-CONFIG_PARAVIRT_XEN_NETDEV_FRONTEND=m
-CONFIG_PARAVIRT_XEN_NETDEV_BACKEND=m
 CONFIG_ISDN=y
 CONFIG_ISDN_I4L=m
 CONFIG_ISDN_PPP=y
@@ -2742,7 +2735,6 @@ CONFIG_INPUT_ADXL34X_SPI=m
 CONFIG_INPUT_IMS_PCU=m
 CONFIG_INPUT_CMA3000=m
 CONFIG_INPUT_CMA3000_I2C=m
-CONFIG_INPUT_XEN_KBDDEV_FRONTEND=m
 
 #
 # Hardware I/O ports
@@ -2835,9 +2827,6 @@ CONFIG_PRINTER=m
 # CONFIG_LP_CONSOLE is not set
 CONFIG_PPDEV=m
 CONFIG_HVC_DRIVER=y
-CONFIG_HVC_IRQ=y
-CONFIG_HVC_XEN=y
-CONFIG_HVC_XEN_FRONTEND=y
 # CONFIG_HVC_DCC is not set
 CONFIG_VIRTIO_CONSOLE=m
 CONFIG_IPMI_HANDLER=m
@@ -2864,7 +2853,6 @@ CONFIG_TCG_TIS_I2C_ATMEL=m
 CONFIG_TCG_TIS_I2C_INFINEON=m
 CONFIG_TCG_TIS_I2C_NUVOTON=m
 CONFIG_TCG_ST33_I2C=m
-CONFIG_TCG_XEN=m
 CONFIG_CRASHER=m
 CONFIG_I2C=y
 CONFIG_I2C_BOARDINFO=y
@@ -3389,7 +3377,6 @@ CONFIG_UX500_WATCHDOG=y
 CONFIG_KEMPLD_WDT=m
 # CONFIG_BCM_KONA_WDT is not set
 CONFIG_MEN_A21_WDT=m
-CONFIG_XEN_WDT=m
 
 #
 # USB-based Watchdog Cards
@@ -4160,7 +4147,6 @@ CONFIG_FB_XILINX=m
 CONFIG_FB_GOLDFISH=m
 CONFIG_FB_DA8XX=m
 CONFIG_FB_VIRTUAL=m
-CONFIG_XEN_FBDEV_FRONTEND=m
 CONFIG_FB_METRONOME=m
 CONFIG_FB_MX3=m
 CONFIG_FB_BROADSHEET=m
@@ -5061,22 +5047,6 @@ CONFIG_VIRTIO_MMIO=m
 #
 # Microsoft Hyper-V guest support
 #
-
-#
-# Xen driver support
-#
-CONFIG_XEN_BALLOON=y
-CONFIG_XEN_SCRUB_PAGES=y
-CONFIG_XEN_DEV_EVTCHN=m
-CONFIG_PARAVIRT_XEN_BACKEND=y
-CONFIG_XENFS=m
-# CONFIG_XEN_COMPAT_XENFS is not set
-CONFIG_XEN_SYS_HYPERVISOR=y
-CONFIG_XEN_XENBUS_FRONTEND=y
-CONFIG_XEN_GNTDEV=m
-CONFIG_XEN_GRANT_DEV_ALLOC=m
-CONFIG_SWIOTLB_XEN=y
-CONFIG_XEN_PRIVCMD=m
 CONFIG_STAGING=y
 CONFIG_USBIP_CORE=m
 CONFIG_USBIP_VHCI_HCD=m
diff --git a/config/armv7hl/exynos b/config/armv7hl/exynos
index f6697ae..34688d8 100644
--- a/config/armv7hl/exynos
+++ b/config/armv7hl/exynos
@@ -523,8 +523,7 @@ CONFIG_UACCESS_WITH_MEMCPY=y
 CONFIG_SECCOMP=y
 CONFIG_SWIOTLB=y
 CONFIG_IOMMU_HELPER=y
-CONFIG_XEN_DOM0=y
-CONFIG_PARAVIRT_XEN=y
+# CONFIG_PARAVIRT_XEN is not set
 
 #
 # Boot options
@@ -1445,7 +1444,7 @@ CONFIG_EXTRA_FIRMWARE=""
 CONFIG_FW_LOADER_USER_HELPER=y
 # CONFIG_DEBUG_DRIVER is not set
 # CONFIG_DEBUG_DEVRES is not set
-CONFIG_SYS_HYPERVISOR=y
+# CONFIG_SYS_HYPERVISOR is not set
 # CONFIG_GENERIC_CPU_DEVICES is not set
 CONFIG_REGMAP=y
 CONFIG_REGMAP_I2C=y
@@ -1671,8 +1670,6 @@ CONFIG_CDROM_PKTCDVD_WCACHE=y
 CONFIG_ATA_OVER_ETH=m
 CONFIG_MG_DISK=m
 CONFIG_MG_DISK_RES=0
-CONFIG_PARAVIRT_XEN_BLKDEV_FRONTEND=m
-CONFIG_PARAVIRT_XEN_BLKDEV_BACKEND=m
 CONFIG_VIRTIO_BLK=m
 CONFIG_BLK_DEV_RBD=m
 
@@ -2176,8 +2173,6 @@ CONFIG_IEEE802154_FAKEHARD=m
 CONFIG_IEEE802154_FAKELB=m
 # CONFIG_IEEE802154_AT86RF230 is not set
 # CONFIG_IEEE802154_MRF24J40 is not set
-CONFIG_PARAVIRT_XEN_NETDEV_FRONTEND=m
-CONFIG_PARAVIRT_XEN_NETDEV_BACKEND=m
 CONFIG_ISDN=y
 CONFIG_ISDN_I4L=m
 CONFIG_ISDN_PPP=y
@@ -2491,7 +2486,6 @@ CONFIG_INPUT_ADXL34X_SPI=m
 # CONFIG_INPUT_IMS_PCU is not set
 CONFIG_INPUT_CMA3000=m
 CONFIG_INPUT_CMA3000_I2C=m
-CONFIG_INPUT_XEN_KBDDEV_FRONTEND=m
 
 #
 # Hardware I/O ports
@@ -2579,9 +2573,6 @@ CONFIG_PRINTER=m
 # CONFIG_LP_CONSOLE is not set
 CONFIG_PPDEV=m
 CONFIG_HVC_DRIVER=y
-CONFIG_HVC_IRQ=y
-CONFIG_HVC_XEN=y
-CONFIG_HVC_XEN_FRONTEND=y
 # CONFIG_HVC_DCC is not set
 CONFIG_VIRTIO_CONSOLE=m
 CONFIG_IPMI_HANDLER=m
@@ -2606,7 +2597,6 @@ CONFIG_TCG_TIS_I2C_ATMEL=m
 CONFIG_TCG_TIS_I2C_INFINEON=m
 CONFIG_TCG_TIS_I2C_NUVOTON=m
 CONFIG_TCG_ST33_I2C=m
-CONFIG_TCG_XEN=m
 CONFIG_CRASHER=m
 CONFIG_I2C=y
 CONFIG_I2C_BOARDINFO=y
@@ -3063,7 +3053,6 @@ CONFIG_TWL4030_WATCHDOG=m
 CONFIG_MAX63XX_WATCHDOG=m
 CONFIG_KEMPLD_WDT=m
 CONFIG_MEN_A21_WDT=m
-CONFIG_XEN_WDT=m
 
 #
 # USB-based Watchdog Cards
@@ -3810,7 +3799,6 @@ CONFIG_FB_SMSCUFX=m
 CONFIG_FB_UDL=m
 CONFIG_FB_GOLDFISH=m
 CONFIG_FB_VIRTUAL=m
-CONFIG_XEN_FBDEV_FRONTEND=m
 CONFIG_FB_METRONOME=m
 CONFIG_FB_BROADSHEET=m
 # CONFIG_FB_AUO_K190X is not set
@@ -4556,22 +4544,6 @@ CONFIG_VIRTIO_MMIO=m
 #
 # Microsoft Hyper-V guest support
 #
-
-#
-# Xen driver support
-#
-CONFIG_XEN_BALLOON=y
-CONFIG_XEN_SCRUB_PAGES=y
-CONFIG_XEN_DEV_EVTCHN=m
-CONFIG_PARAVIRT_XEN_BACKEND=y
-CONFIG_XENFS=m
-# CONFIG_XEN_COMPAT_XENFS is not set
-CONFIG_XEN_SYS_HYPERVISOR=y
-CONFIG_XEN_XENBUS_FRONTEND=y
-CONFIG_XEN_GNTDEV=m
-CONFIG_XEN_GRANT_DEV_ALLOC=m
-CONFIG_SWIOTLB_XEN=y
-CONFIG_XEN_PRIVCMD=m
 CONFIG_STAGING=y
 CONFIG_USBIP_CORE=m
 CONFIG_USBIP_VHCI_HCD=m
diff --git a/config/armv7hl/lpae b/config/armv7hl/lpae
index 828b6e2..2c1d0da 100644
--- a/config/armv7hl/lpae
+++ b/config/armv7hl/lpae
@@ -377,7 +377,6 @@ CONFIG_HAVE_IMX_SRC=y
 # CONFIG_MACH_IMX51_DT is not set
 # CONFIG_MACH_MX51_BABBAGE is not set
 # CONFIG_MACH_EUKREA_CPUIMX51SD is not set
-# CONFIG_MACH_EUKREA_MBIMXSD51_BASEBOARD is not set
 
 #
 # Device tree only
@@ -613,8 +612,7 @@ CONFIG_UACCESS_WITH_MEMCPY=y
 CONFIG_SECCOMP=y
 CONFIG_SWIOTLB=y
 CONFIG_IOMMU_HELPER=y
-CONFIG_XEN_DOM0=y
-CONFIG_PARAVIRT_XEN=y
+# CONFIG_PARAVIRT_XEN is not set
 
 #
 # Boot options
@@ -1534,7 +1532,7 @@ CONFIG_EXTRA_FIRMWARE=""
 CONFIG_FW_LOADER_USER_HELPER=y
 # CONFIG_DEBUG_DRIVER is not set
 # CONFIG_DEBUG_DEVRES is not set
-CONFIG_SYS_HYPERVISOR=y
+# CONFIG_SYS_HYPERVISOR is not set
 # CONFIG_GENERIC_CPU_DEVICES is not set
 CONFIG_SOC_BUS=y
 CONFIG_REGMAP=y
@@ -1767,8 +1765,6 @@ CONFIG_CDROM_PKTCDVD_WCACHE=y
 CONFIG_ATA_OVER_ETH=m
 CONFIG_MG_DISK=m
 CONFIG_MG_DISK_RES=0
-CONFIG_PARAVIRT_XEN_BLKDEV_FRONTEND=m
-CONFIG_PARAVIRT_XEN_BLKDEV_BACKEND=m
 CONFIG_VIRTIO_BLK=m
 CONFIG_BLK_DEV_RBD=m
 
@@ -2288,8 +2284,6 @@ CONFIG_IEEE802154_FAKEHARD=m
 CONFIG_IEEE802154_FAKELB=m
 # CONFIG_IEEE802154_AT86RF230 is not set
 # CONFIG_IEEE802154_MRF24J40 is not set
-CONFIG_PARAVIRT_XEN_NETDEV_FRONTEND=m
-CONFIG_PARAVIRT_XEN_NETDEV_BACKEND=m
 CONFIG_ISDN=y
 CONFIG_ISDN_I4L=m
 CONFIG_ISDN_PPP=y
@@ -2606,7 +2600,6 @@ CONFIG_INPUT_ADXL34X_SPI=m
 CONFIG_INPUT_IMS_PCU=m
 CONFIG_INPUT_CMA3000=m
 CONFIG_INPUT_CMA3000_I2C=m
-CONFIG_INPUT_XEN_KBDDEV_FRONTEND=m
 
 #
 # Hardware I/O ports
@@ -2696,9 +2689,6 @@ CONFIG_PRINTER=m
 # CONFIG_LP_CONSOLE is not set
 CONFIG_PPDEV=m
 CONFIG_HVC_DRIVER=y
-CONFIG_HVC_IRQ=y
-CONFIG_HVC_XEN=y
-CONFIG_HVC_XEN_FRONTEND=y
 # CONFIG_HVC_DCC is not set
 CONFIG_VIRTIO_CONSOLE=m
 CONFIG_IPMI_HANDLER=m
@@ -2724,7 +2714,6 @@ CONFIG_TCG_TIS_I2C_ATMEL=m
 CONFIG_TCG_TIS_I2C_INFINEON=m
 CONFIG_TCG_TIS_I2C_NUVOTON=m
 CONFIG_TCG_ST33_I2C=m
-CONFIG_TCG_XEN=m
 CONFIG_CRASHER=m
 CONFIG_I2C=y
 CONFIG_I2C_BOARDINFO=y
@@ -3195,7 +3184,6 @@ CONFIG_MAX63XX_WATCHDOG=m
 CONFIG_IMX2_WDT=m
 CONFIG_KEMPLD_WDT=m
 CONFIG_MEN_A21_WDT=m
-CONFIG_XEN_WDT=m
 
 #
 # USB-based Watchdog Cards
@@ -3946,7 +3934,6 @@ CONFIG_FB_SMSCUFX=m
 CONFIG_FB_UDL=m
 CONFIG_FB_GOLDFISH=m
 CONFIG_FB_VIRTUAL=m
-CONFIG_XEN_FBDEV_FRONTEND=m
 CONFIG_FB_METRONOME=m
 CONFIG_FB_MX3=m
 CONFIG_FB_BROADSHEET=m
@@ -4774,22 +4761,6 @@ CONFIG_VIRTIO_MMIO=m
 #
 # Microsoft Hyper-V guest support
 #
-
-#
-# Xen driver support
-#
-CONFIG_XEN_BALLOON=y
-CONFIG_XEN_SCRUB_PAGES=y
-CONFIG_XEN_DEV_EVTCHN=m
-CONFIG_PARAVIRT_XEN_BACKEND=y
-CONFIG_XENFS=m
-# CONFIG_XEN_COMPAT_XENFS is not set
-CONFIG_XEN_SYS_HYPERVISOR=y
-CONFIG_XEN_XENBUS_FRONTEND=y
-CONFIG_XEN_GNTDEV=m
-CONFIG_XEN_GRANT_DEV_ALLOC=m
-CONFIG_SWIOTLB_XEN=y
-CONFIG_XEN_PRIVCMD=m
 CONFIG_STAGING=y
 CONFIG_USBIP_CORE=m
 CONFIG_USBIP_VHCI_HCD=m
-- 
1.7.10.4