>From bd170ce945c97bdd83af9273d0210a87916e5d7a Mon Sep 17 00:00:00 2001
From: Guillaume GARDET <guillaume.gardet@oliseo.fr>
Date: Tue, 11 Feb 2014 14:59:07 +0100
Subject: [PATCH] Enhances exynos support:  * Add sound support  * Add I2C/SPI
 support

---
 config/armv7hl/exynos |  224 +++++++++++++++++++++++++++++++++++++++++++++----
 1 file changed, 210 insertions(+), 14 deletions(-)

diff --git a/config/armv7hl/exynos b/config/armv7hl/exynos
index 33c0c68..41ebc4f 100644
--- a/config/armv7hl/exynos
+++ b/config/armv7hl/exynos
@@ -1,6 +1,6 @@
 #
 # Automatically generated file; DO NOT EDIT.
-# Linux/arm 3.13.0 Kernel Configuration
+# Linux/arm 3.13.2 Kernel Configuration
 #
 CONFIG_ARM=y
 CONFIG_MIGHT_HAVE_PCI=y
@@ -1233,6 +1233,7 @@ CONFIG_CAN_DEV=m
 CONFIG_CAN_CALC_BITTIMING=y
 CONFIG_CAN_LEDS=y
 # CONFIG_CAN_AT91 is not set
+# CONFIG_CAN_MCP251X is not set
 # CONFIG_CAN_FLEXCAN is not set
 # CONFIG_CAN_GRCAN is not set
 CONFIG_CAN_SJA1000=m
@@ -1389,6 +1390,7 @@ CONFIG_CEPH_LIB_PRETTYDEBUG=y
 CONFIG_NFC=m
 CONFIG_NFC_DIGITAL=m
 CONFIG_NFC_NCI=m
+# CONFIG_NFC_NCI_SPI is not set
 CONFIG_NFC_HCI=m
 # CONFIG_NFC_SHDLC is not set
 
@@ -1425,6 +1427,7 @@ CONFIG_SYS_HYPERVISOR=y
 # CONFIG_GENERIC_CPU_DEVICES is not set
 CONFIG_REGMAP=y
 CONFIG_REGMAP_I2C=y
+CONFIG_REGMAP_SPI=m
 CONFIG_REGMAP_MMIO=y
 CONFIG_REGMAP_IRQ=y
 CONFIG_DMA_SHARED_BUFFER=y
@@ -1522,6 +1525,9 @@ CONFIG_MTD_LATCH_ADDR=m
 #
 # Self-contained MTD device drivers
 #
+# CONFIG_MTD_DATAFLASH is not set
+# CONFIG_MTD_M25P80 is not set
+# CONFIG_MTD_SST25L is not set
 CONFIG_MTD_SLRAM=m
 CONFIG_MTD_PHRAM=m
 CONFIG_MTD_MTDRAM=m
@@ -1652,6 +1658,7 @@ CONFIG_BLK_DEV_RBD=m
 CONFIG_SENSORS_LIS3LV02D=m
 CONFIG_AD525X_DPOT=m
 CONFIG_AD525X_DPOT_I2C=m
+# CONFIG_AD525X_DPOT_SPI is not set
 # CONFIG_ATMEL_PWM is not set
 CONFIG_DUMMY_IRQ=m
 CONFIG_ICS932S401=m
@@ -1666,8 +1673,11 @@ CONFIG_SENSORS_BH1770=m
 CONFIG_SENSORS_APDS990X=m
 CONFIG_HMC6352=m
 CONFIG_DS1682=m
+# CONFIG_TI_DAC7512 is not set
 # CONFIG_BMP085_I2C is not set
+# CONFIG_BMP085_SPI is not set
 CONFIG_USB_SWITCH_FSA9480=m
+# CONFIG_LATTICE_ECP3_CONFIG is not set
 # CONFIG_SRAM is not set
 CONFIG_C2PORT=m
 
@@ -1675,14 +1685,17 @@ CONFIG_C2PORT=m
 # EEPROM support
 #
 CONFIG_EEPROM_AT24=m
+# CONFIG_EEPROM_AT25 is not set
 CONFIG_EEPROM_LEGACY=m
 CONFIG_EEPROM_MAX6875=m
 CONFIG_EEPROM_93CX6=m
+# CONFIG_EEPROM_93XX46 is not set
 
 #
 # Texas Instruments shared transport line discipline
 #
 CONFIG_TI_ST=m
+# CONFIG_SENSORS_LIS3_SPI is not set
 CONFIG_SENSORS_LIS3_I2C=m
 
 #
@@ -1910,7 +1923,10 @@ CONFIG_NET_VENDOR_MARVELL=y
 CONFIG_MVMDIO=m
 CONFIG_NET_VENDOR_MICREL=y
 CONFIG_KS8842=m
+# CONFIG_KS8851 is not set
 CONFIG_KS8851_MLL=m
+CONFIG_NET_VENDOR_MICROCHIP=y
+# CONFIG_ENC28J60 is not set
 CONFIG_NET_VENDOR_NATSEMI=y
 CONFIG_NET_VENDOR_8390=y
 # CONFIG_AX88796 is not set
@@ -1959,6 +1975,7 @@ CONFIG_MDIO_GPIO=m
 CONFIG_MDIO_BUS_MUX=m
 CONFIG_MDIO_BUS_MUX_GPIO=m
 CONFIG_MDIO_BUS_MUX_MMIOREG=m
+# CONFIG_MICREL_KS8995MA is not set
 CONFIG_PLIP=m
 CONFIG_PPP=m
 CONFIG_PPP_BSDCOMP=m
@@ -2048,7 +2065,11 @@ CONFIG_CARL9170_LEDS=y
 # CONFIG_CARL9170_DEBUGFS is not set
 CONFIG_CARL9170_WPC=y
 # CONFIG_CARL9170_HWRNG is not set
-# CONFIG_ATH6KL is not set
+CONFIG_ATH6KL=m
+CONFIG_ATH6KL_SDIO=m
+CONFIG_ATH6KL_USB=m
+# CONFIG_ATH6KL_DEBUG is not set
+# CONFIG_ATH6KL_TRACING is not set
 CONFIG_AR5523=m
 CONFIG_ATH10K=m
 # CONFIG_ATH10K_DEBUG is not set
@@ -2069,10 +2090,12 @@ CONFIG_HOSTAP_FIRMWARE_NVRAM=y
 CONFIG_LIBERTAS=m
 CONFIG_LIBERTAS_USB=m
 CONFIG_LIBERTAS_SDIO=m
+# CONFIG_LIBERTAS_SPI is not set
 # CONFIG_LIBERTAS_DEBUG is not set
 CONFIG_LIBERTAS_MESH=y
 CONFIG_P54_COMMON=m
 CONFIG_P54_USB=m
+# CONFIG_P54_SPI is not set
 CONFIG_P54_LEDS=y
 CONFIG_RT2X00=m
 CONFIG_RT2500USB=m
@@ -2127,6 +2150,8 @@ CONFIG_X25_ASY=m
 CONFIG_IEEE802154_DRIVERS=m
 CONFIG_IEEE802154_FAKEHARD=m
 CONFIG_IEEE802154_FAKELB=m
+# CONFIG_IEEE802154_AT86RF230 is not set
+# CONFIG_IEEE802154_MRF24J40 is not set
 CONFIG_PARAVIRT_XEN_NETDEV_FRONTEND=m
 CONFIG_PARAVIRT_XEN_NETDEV_BACKEND=m
 CONFIG_ISDN=y
@@ -2335,14 +2360,18 @@ CONFIG_TABLET_USB_KBTAB=m
 CONFIG_TABLET_USB_WACOM=m
 CONFIG_INPUT_TOUCHSCREEN=y
 CONFIG_TOUCHSCREEN_88PM860X=m
+# CONFIG_TOUCHSCREEN_ADS7846 is not set
+# CONFIG_TOUCHSCREEN_AD7877 is not set
 CONFIG_TOUCHSCREEN_AD7879=m
 CONFIG_TOUCHSCREEN_AD7879_I2C=m
+# CONFIG_TOUCHSCREEN_AD7879_SPI is not set
 CONFIG_TOUCHSCREEN_ATMEL_MXT=m
 CONFIG_TOUCHSCREEN_AUO_PIXCIR=m
 CONFIG_TOUCHSCREEN_BU21013=m
 CONFIG_TOUCHSCREEN_CY8CTMG110=m
 CONFIG_TOUCHSCREEN_CYTTSP_CORE=m
 CONFIG_TOUCHSCREEN_CYTTSP_I2C=m
+# CONFIG_TOUCHSCREEN_CYTTSP_SPI is not set
 # CONFIG_TOUCHSCREEN_CYTTSP4_CORE is not set
 CONFIG_TOUCHSCREEN_DA9034=m
 CONFIG_TOUCHSCREEN_DA9052=m
@@ -2395,6 +2424,7 @@ CONFIG_TOUCHSCREEN_USB_NEXIO=y
 CONFIG_TOUCHSCREEN_USB_EASYTOUCH=y
 CONFIG_TOUCHSCREEN_TOUCHIT213=m
 # CONFIG_TOUCHSCREEN_TSC_SERIO is not set
+# CONFIG_TOUCHSCREEN_TSC2005 is not set
 CONFIG_TOUCHSCREEN_TSC2007=m
 CONFIG_TOUCHSCREEN_W90X900=m
 CONFIG_TOUCHSCREEN_ST1232=m
@@ -2407,6 +2437,8 @@ CONFIG_INPUT_88PM860X_ONKEY=m
 CONFIG_INPUT_88PM80X_ONKEY=m
 CONFIG_INPUT_AD714X=m
 CONFIG_INPUT_AD714X_I2C=m
+CONFIG_INPUT_AD714X_SPI=m
+# CONFIG_INPUT_ARIZONA_HAPTICS is not set
 # CONFIG_INPUT_BMA150 is not set
 CONFIG_INPUT_MAX8925_ONKEY=m
 CONFIG_INPUT_MMA8450=m
@@ -2431,6 +2463,7 @@ CONFIG_INPUT_DA9055_ONKEY=m
 CONFIG_INPUT_WM831X_ON=m
 CONFIG_INPUT_ADXL34X=m
 CONFIG_INPUT_ADXL34X_I2C=m
+CONFIG_INPUT_ADXL34X_SPI=m
 # CONFIG_INPUT_IMS_PCU is not set
 CONFIG_INPUT_CMA3000=m
 CONFIG_INPUT_CMA3000_I2C=m
@@ -2498,6 +2531,8 @@ CONFIG_SERIAL_SAMSUNG=y
 CONFIG_SERIAL_SAMSUNG_UARTS_4=y
 CONFIG_SERIAL_SAMSUNG_UARTS=4
 CONFIG_SERIAL_SAMSUNG_CONSOLE=y
+# CONFIG_SERIAL_MAX3100 is not set
+# CONFIG_SERIAL_MAX310X is not set
 CONFIG_SERIAL_SH_SCI=m
 CONFIG_SERIAL_SH_SCI_NR_UARTS=2
 CONFIG_SERIAL_CORE=y
@@ -2510,6 +2545,7 @@ CONFIG_SERIAL_ALTERA_JTAGUART=m
 CONFIG_SERIAL_ALTERA_UART=m
 CONFIG_SERIAL_ALTERA_UART_MAXPORTS=4
 CONFIG_SERIAL_ALTERA_UART_BAUDRATE=115200
+# CONFIG_SERIAL_IFX6X60 is not set
 CONFIG_SERIAL_XILINX_PS_UART=m
 # CONFIG_SERIAL_ARC is not set
 CONFIG_SERIAL_FSL_LPUART=m
@@ -2550,18 +2586,27 @@ CONFIG_TCG_XEN=m
 CONFIG_CRASHER=m
 CONFIG_I2C=y
 CONFIG_I2C_BOARDINFO=y
-# CONFIG_I2C_COMPAT is not set
-# CONFIG_I2C_CHARDEV is not set
-# CONFIG_I2C_MUX is not set
+CONFIG_I2C_COMPAT=y
+CONFIG_I2C_CHARDEV=m
+CONFIG_I2C_MUX=m
+
+#
+# Multiplexer I2C Chip support
+#
+CONFIG_I2C_ARB_GPIO_CHALLENGE=m
+CONFIG_I2C_MUX_GPIO=m
+CONFIG_I2C_MUX_PCA9541=m
+CONFIG_I2C_MUX_PCA954x=m
+CONFIG_I2C_MUX_PINCTRL=m
 # CONFIG_I2C_HELPER_AUTO is not set
-# CONFIG_I2C_SMBUS is not set
+CONFIG_I2C_SMBUS=m
 
 #
 # I2C Algorithms
 #
 CONFIG_I2C_ALGOBIT=y
-# CONFIG_I2C_ALGOPCF is not set
-# CONFIG_I2C_ALGOPCA is not set
+CONFIG_I2C_ALGOPCF=m
+CONFIG_I2C_ALGOPCA=m
 
 #
 # I2C Hardware Bus support
@@ -2603,7 +2648,33 @@ CONFIG_I2C_STUB=m
 # CONFIG_I2C_DEBUG_CORE is not set
 # CONFIG_I2C_DEBUG_ALGO is not set
 # CONFIG_I2C_DEBUG_BUS is not set
-# CONFIG_SPI is not set
+CONFIG_SPI=y
+# CONFIG_SPI_DEBUG is not set
+CONFIG_SPI_MASTER=y
+
+#
+# SPI Master Controller Drivers
+#
+# CONFIG_SPI_ALTERA is not set
+# CONFIG_SPI_BITBANG is not set
+# CONFIG_SPI_BUTTERFLY is not set
+# CONFIG_SPI_GPIO is not set
+# CONFIG_SPI_LM70_LLP is not set
+# CONFIG_SPI_FSL_SPI is not set
+# CONFIG_SPI_OC_TINY is not set
+# CONFIG_SPI_PL022 is not set
+# CONFIG_SPI_PXA2XX_PCI is not set
+CONFIG_SPI_S3C64XX=m
+# CONFIG_SPI_SC18IS602 is not set
+# CONFIG_SPI_XCOMM is not set
+# CONFIG_SPI_XILINX is not set
+# CONFIG_SPI_DESIGNWARE is not set
+
+#
+# SPI Protocol Masters
+#
+# CONFIG_SPI_SPIDEV is not set
+# CONFIG_SPI_TLE62X0 is not set
 # CONFIG_HSI is not set
 
 #
@@ -2697,7 +2768,10 @@ CONFIG_GPIO_ADNP=m
 #
 # SPI GPIO expanders:
 #
+# CONFIG_GPIO_MAX7301 is not set
 CONFIG_GPIO_MCP23S08=m
+# CONFIG_GPIO_MC33880 is not set
+# CONFIG_GPIO_74X164 is not set
 
 #
 # AC97 GPIO expanders:
@@ -2801,8 +2875,10 @@ CONFIG_HWMON_VID=m
 #
 # Native drivers
 #
+# CONFIG_SENSORS_AD7314 is not set
 CONFIG_SENSORS_AD7414=m
 CONFIG_SENSORS_AD7418=m
+# CONFIG_SENSORS_ADCXX is not set
 CONFIG_SENSORS_ADM1021=m
 CONFIG_SENSORS_ADM1025=m
 CONFIG_SENSORS_ADM1026=m
@@ -2810,6 +2886,7 @@ CONFIG_SENSORS_ADM1029=m
 CONFIG_SENSORS_ADM1031=m
 CONFIG_SENSORS_ADM9240=m
 CONFIG_SENSORS_ADT7X10=m
+# CONFIG_SENSORS_ADT7310 is not set
 CONFIG_SENSORS_ADT7410=m
 CONFIG_SENSORS_ADT7411=m
 CONFIG_SENSORS_ADT7462=m
@@ -2838,6 +2915,7 @@ CONFIG_SENSORS_IT87=m
 CONFIG_SENSORS_JC42=m
 CONFIG_SENSORS_LINEAGE=m
 CONFIG_SENSORS_LM63=m
+# CONFIG_SENSORS_LM70 is not set
 CONFIG_SENSORS_LM73=m
 CONFIG_SENSORS_LM75=m
 CONFIG_SENSORS_LM77=m
@@ -2856,6 +2934,7 @@ CONFIG_SENSORS_LTC4261=m
 # CONFIG_SENSORS_LM95234 is not set
 CONFIG_SENSORS_LM95241=m
 CONFIG_SENSORS_LM95245=m
+# CONFIG_SENSORS_MAX1111 is not set
 CONFIG_SENSORS_MAX16065=m
 CONFIG_SENSORS_MAX1619=m
 CONFIG_SENSORS_MAX1668=m
@@ -2896,6 +2975,7 @@ CONFIG_SENSORS_SCH5627=m
 CONFIG_SENSORS_SCH5636=m
 CONFIG_SENSORS_ADS1015=m
 CONFIG_SENSORS_ADS7828=m
+# CONFIG_SENSORS_ADS7871 is not set
 CONFIG_SENSORS_AMC6821=m
 CONFIG_SENSORS_INA209=m
 # CONFIG_SENSORS_INA2XX is not set
@@ -2999,12 +3079,15 @@ CONFIG_PMIC_ADP5520=y
 CONFIG_MFD_AAT2870_CORE=y
 CONFIG_MFD_CROS_EC=m
 CONFIG_MFD_CROS_EC_I2C=m
+# CONFIG_MFD_CROS_EC_SPI is not set
 CONFIG_MFD_ASIC3=y
 CONFIG_PMIC_DA903X=y
 CONFIG_PMIC_DA9052=y
+# CONFIG_MFD_DA9052_SPI is not set
 CONFIG_MFD_DA9052_I2C=y
 CONFIG_MFD_DA9055=y
 CONFIG_MFD_DA9063=y
+# CONFIG_MFD_MC13XXX_SPI is not set
 # CONFIG_MFD_MC13XXX_I2C is not set
 CONFIG_HTC_EGPIO=y
 CONFIG_HTC_PASIC3=m
@@ -3019,6 +3102,7 @@ CONFIG_MFD_MAX8907=y
 CONFIG_MFD_MAX8925=y
 CONFIG_MFD_MAX8997=y
 CONFIG_MFD_MAX8998=y
+# CONFIG_EZX_PCAP is not set
 CONFIG_MFD_VIPERBOARD=m
 # CONFIG_MFD_RETU is not set
 # CONFIG_MFD_PCF50633 is not set
@@ -3036,6 +3120,7 @@ CONFIG_MFD_STMPE=y
 # STMicroelectronics STMPE Interface Drivers
 #
 CONFIG_STMPE_I2C=y
+# CONFIG_STMPE_SPI is not set
 CONFIG_MFD_SYSCON=y
 CONFIG_MFD_TI_AM335X_TSCADC=m
 CONFIG_MFD_LP8788=y
@@ -3049,6 +3134,7 @@ CONFIG_MFD_TPS6586X=y
 CONFIG_MFD_TPS65910=y
 CONFIG_MFD_TPS65912=y
 CONFIG_MFD_TPS65912_I2C=y
+# CONFIG_MFD_TPS65912_SPI is not set
 CONFIG_MFD_TPS80031=y
 CONFIG_TWL4030_CORE=y
 CONFIG_TWL4030_MADC=m
@@ -3064,12 +3150,14 @@ CONFIG_MFD_TC6387XB=y
 CONFIG_MFD_TC6393XB=y
 CONFIG_MFD_ARIZONA=y
 CONFIG_MFD_ARIZONA_I2C=m
+# CONFIG_MFD_ARIZONA_SPI is not set
 # CONFIG_MFD_WM5102 is not set
 # CONFIG_MFD_WM5110 is not set
 # CONFIG_MFD_WM8997 is not set
 CONFIG_MFD_WM8400=y
 CONFIG_MFD_WM831X=y
 CONFIG_MFD_WM831X_I2C=y
+# CONFIG_MFD_WM831X_SPI is not set
 CONFIG_MFD_WM8350=y
 CONFIG_MFD_WM8350_I2C=y
 CONFIG_MFD_WM8994=y
@@ -3084,6 +3172,7 @@ CONFIG_REGULATOR_88PM8607=y
 CONFIG_REGULATOR_AD5398=m
 CONFIG_REGULATOR_ANATOP=m
 CONFIG_REGULATOR_AAT2870=m
+# CONFIG_REGULATOR_ARIZONA is not set
 CONFIG_REGULATOR_AS3711=m
 CONFIG_REGULATOR_AS3722=m
 CONFIG_REGULATOR_DA903X=m
@@ -3122,6 +3211,7 @@ CONFIG_REGULATOR_TPS65023=m
 CONFIG_REGULATOR_TPS6507X=m
 CONFIG_REGULATOR_TPS65090=m
 CONFIG_REGULATOR_TPS65217=m
+# CONFIG_REGULATOR_TPS6524X is not set
 CONFIG_REGULATOR_TPS6586X=m
 CONFIG_REGULATOR_TPS65910=m
 CONFIG_REGULATOR_TPS65912=m
@@ -3639,7 +3729,7 @@ CONFIG_DRM_I2C_SIL164=m
 CONFIG_DRM_I2C_NXP_TDA998X=m
 CONFIG_DRM_EXYNOS=m
 CONFIG_DRM_EXYNOS_DMABUF=y
-CONFIG_DRM_EXYNOS_FIMD=y
+# CONFIG_DRM_EXYNOS_FIMD is not set
 # CONFIG_DRM_EXYNOS_VIDI is not set
 # CONFIG_DRM_EXYNOS_G2D is not set
 # CONFIG_DRM_EXYNOS_IPP is not set
@@ -3698,7 +3788,19 @@ CONFIG_EXYNOS_LCD_S6E8AX0=y
 CONFIG_EXYNOS_DP=y
 CONFIG_BACKLIGHT_LCD_SUPPORT=y
 CONFIG_LCD_CLASS_DEVICE=y
+# CONFIG_LCD_L4F00242T03 is not set
+# CONFIG_LCD_LMS283GF05 is not set
+# CONFIG_LCD_LTV350QV is not set
+# CONFIG_LCD_ILI922X is not set
+# CONFIG_LCD_ILI9320 is not set
+# CONFIG_LCD_TDO24M is not set
+# CONFIG_LCD_VGG2432A4 is not set
 CONFIG_LCD_PLATFORM=y
+# CONFIG_LCD_S6E63M0 is not set
+# CONFIG_LCD_LD9040 is not set
+# CONFIG_LCD_AMS369FG06 is not set
+# CONFIG_LCD_LMS501KF03 is not set
+# CONFIG_LCD_HX8357 is not set
 CONFIG_BACKLIGHT_CLASS_DEVICE=y
 CONFIG_BACKLIGHT_GENERIC=m
 CONFIG_BACKLIGHT_PWM=m
@@ -3728,7 +3830,7 @@ CONFIG_BACKLIGHT_BD6107=m
 CONFIG_DUMMY_CONSOLE=y
 CONFIG_FRAMEBUFFER_CONSOLE=y
 CONFIG_FRAMEBUFFER_CONSOLE_DETECT_PRIMARY=y
-# CONFIG_FRAMEBUFFER_CONSOLE_ROTATION is not set
+CONFIG_FRAMEBUFFER_CONSOLE_ROTATION=y
 CONFIG_LOGO=y
 CONFIG_LOGO_LINUX_MONO=y
 CONFIG_LOGO_LINUX_VGA16=y
@@ -3742,6 +3844,8 @@ CONFIG_SND_TIMER=m
 CONFIG_SND_PCM=m
 CONFIG_SND_HWDEP=m
 CONFIG_SND_RAWMIDI=m
+CONFIG_SND_COMPRESS_OFFLOAD=m
+CONFIG_SND_JACK=y
 CONFIG_SND_SEQUENCER=m
 CONFIG_SND_SEQ_DUMMY=m
 CONFIG_SND_OSSEMUL=y
@@ -3780,6 +3884,8 @@ CONFIG_SND_AC97_POWER_SAVE=y
 CONFIG_SND_AC97_POWER_SAVE_DEFAULT=0
 CONFIG_SND_ARM=y
 CONFIG_SND_ARMAACI=m
+CONFIG_SND_SPI=y
+# CONFIG_SND_AT73C213 is not set
 CONFIG_SND_USB=y
 CONFIG_SND_USB_AUDIO=m
 CONFIG_SND_USB_UA101=m
@@ -3787,7 +3893,21 @@ CONFIG_SND_USB_CAIAQ=m
 CONFIG_SND_USB_CAIAQ_INPUT=y
 CONFIG_SND_USB_6FIRE=m
 CONFIG_SND_USB_HIFACE=m
-# CONFIG_SND_SOC is not set
+CONFIG_SND_SOC=m
+# CONFIG_SND_ATMEL_SOC is not set
+# CONFIG_SND_DESIGNWARE_I2S is not set
+CONFIG_SND_SOC_SAMSUNG=m
+CONFIG_SND_SAMSUNG_PCM=m
+CONFIG_SND_SAMSUNG_SPDIF=m
+CONFIG_SND_SAMSUNG_I2S=m
+CONFIG_SND_SOC_SAMSUNG_SMDK_WM8994=m
+CONFIG_SND_SOC_SAMSUNG_SMDK_SPDIF=m
+CONFIG_SND_SOC_SMDK_WM8994_PCM=m
+CONFIG_SND_SOC_I2C_AND_SPI=m
+CONFIG_SND_SOC_WM_HUBS=m
+CONFIG_SND_SOC_SPDIF=m
+CONFIG_SND_SOC_WM8994=m
+# CONFIG_SND_SIMPLE_CARD is not set
 CONFIG_SOUND_PRIME=m
 CONFIG_AC97_BUS=m
 
@@ -4211,6 +4331,7 @@ CONFIG_LEDS_WM831X_STATUS=m
 CONFIG_LEDS_WM8350=m
 CONFIG_LEDS_DA903X=m
 CONFIG_LEDS_DA9052=m
+# CONFIG_LEDS_DAC124S085 is not set
 CONFIG_LEDS_PWM=m
 CONFIG_LEDS_REGULATOR=m
 CONFIG_LEDS_BD2802=m
@@ -4303,6 +4424,16 @@ CONFIG_RTC_DRV_S5M=y
 #
 # SPI RTC drivers
 #
+# CONFIG_RTC_DRV_M41T93 is not set
+# CONFIG_RTC_DRV_M41T94 is not set
+# CONFIG_RTC_DRV_DS1305 is not set
+# CONFIG_RTC_DRV_DS1390 is not set
+# CONFIG_RTC_DRV_MAX6902 is not set
+# CONFIG_RTC_DRV_R9701 is not set
+# CONFIG_RTC_DRV_RS5C348 is not set
+# CONFIG_RTC_DRV_DS3234 is not set
+# CONFIG_RTC_DRV_PCF2123 is not set
+# CONFIG_RTC_DRV_RX4581 is not set
 
 #
 # Platform RTC drivers
@@ -4429,6 +4560,14 @@ CONFIG_VT6656=m
 #
 # Accelerometers
 #
+# CONFIG_ADIS16201 is not set
+# CONFIG_ADIS16203 is not set
+# CONFIG_ADIS16204 is not set
+# CONFIG_ADIS16209 is not set
+# CONFIG_ADIS16220 is not set
+# CONFIG_ADIS16240 is not set
+# CONFIG_LIS3L02DQ is not set
+# CONFIG_SCA3000 is not set
 
 #
 # Analog to digital converters
@@ -4436,13 +4575,19 @@ CONFIG_VT6656=m
 CONFIG_AD7291=m
 CONFIG_AD7606=m
 CONFIG_AD7606_IFACE_PARALLEL=m
+# CONFIG_AD7606_IFACE_SPI is not set
 CONFIG_AD799X=m
 CONFIG_AD799X_RING_BUFFER=y
+# CONFIG_AD7780 is not set
+# CONFIG_AD7816 is not set
+# CONFIG_AD7192 is not set
+# CONFIG_AD7280 is not set
 
 #
 # Analog digital bi-direction converters
 #
 CONFIG_ADT7316=m
+CONFIG_ADT7316_SPI=m
 CONFIG_ADT7316_I2C=m
 
 #
@@ -4455,10 +4600,18 @@ CONFIG_AD7746=m
 #
 # Direct Digital Synthesis
 #
+# CONFIG_AD5930 is not set
+# CONFIG_AD9832 is not set
+# CONFIG_AD9834 is not set
+# CONFIG_AD9850 is not set
+# CONFIG_AD9852 is not set
+# CONFIG_AD9910 is not set
+# CONFIG_AD9951 is not set
 
 #
 # Digital gyroscope sensors
 #
+# CONFIG_ADIS16060 is not set
 
 #
 # Network Analyzer, Impedance Converters
@@ -4481,12 +4634,20 @@ CONFIG_SENSORS_HMC5843=m
 #
 # Active energy metering IC
 #
+# CONFIG_ADE7753 is not set
+# CONFIG_ADE7754 is not set
+# CONFIG_ADE7758 is not set
+# CONFIG_ADE7759 is not set
 CONFIG_ADE7854=m
 CONFIG_ADE7854_I2C=m
+CONFIG_ADE7854_SPI=m
 
 #
 # Resolver to digital converters
 #
+# CONFIG_AD2S90 is not set
+# CONFIG_AD2S1200 is not set
+# CONFIG_AD2S1210 is not set
 
 #
 # Triggers - standalone
@@ -4535,6 +4696,7 @@ CONFIG_USB_WPAN_HCD=m
 CONFIG_LTE_GDM724X=m
 CONFIG_CED1401=m
 CONFIG_DGRP=m
+# CONFIG_MTD_SPINAND_MT29F is not set
 CONFIG_USB_DWC2=m
 # CONFIG_USB_DWC2_DEBUG is not set
 # CONFIG_USB_DWC2_TRACK_MISSED_SOFS is not set
@@ -4605,13 +4767,23 @@ CONFIG_BMA180=m
 CONFIG_HID_SENSOR_ACCEL_3D=m
 CONFIG_IIO_ST_ACCEL_3AXIS=m
 CONFIG_IIO_ST_ACCEL_I2C_3AXIS=m
+CONFIG_IIO_ST_ACCEL_SPI_3AXIS=m
+# CONFIG_KXSD9 is not set
 
 #
 # Analog to digital converters
 #
-# CONFIG_EXYNOS_ADC is not set
+# CONFIG_AD7266 is not set
+# CONFIG_AD7298 is not set
+# CONFIG_AD7476 is not set
+# CONFIG_AD7791 is not set
+# CONFIG_AD7793 is not set
+# CONFIG_AD7887 is not set
+# CONFIG_AD7923 is not set
+CONFIG_EXYNOS_ADC=y
 CONFIG_LP8788_ADC=y
 CONFIG_MAX1363=m
+# CONFIG_MCP320X is not set
 CONFIG_MCP3422=m
 CONFIG_NAU7802=m
 CONFIG_TI_ADC081C=m
@@ -4622,6 +4794,7 @@ CONFIG_VIPERBOARD_ADC=m
 #
 # Amplifiers
 #
+# CONFIG_AD8366 is not set
 
 #
 # Hid Sensor IIO Common
@@ -4629,14 +4802,25 @@ CONFIG_VIPERBOARD_ADC=m
 CONFIG_HID_SENSOR_IIO_COMMON=m
 CONFIG_HID_SENSOR_IIO_TRIGGER=m
 CONFIG_IIO_ST_SENSORS_I2C=m
+CONFIG_IIO_ST_SENSORS_SPI=m
 CONFIG_IIO_ST_SENSORS_CORE=m
 
 #
 # Digital to analog converters
 #
 CONFIG_AD5064=m
+# CONFIG_AD5360 is not set
 CONFIG_AD5380=m
+# CONFIG_AD5421 is not set
 CONFIG_AD5446=m
+# CONFIG_AD5449 is not set
+# CONFIG_AD5504 is not set
+# CONFIG_AD5624R_SPI is not set
+# CONFIG_AD5686 is not set
+# CONFIG_AD5755 is not set
+# CONFIG_AD5764 is not set
+# CONFIG_AD5791 is not set
+# CONFIG_AD7303 is not set
 CONFIG_MAX517=m
 CONFIG_MCP4725=m
 
@@ -4647,22 +4831,32 @@ CONFIG_MCP4725=m
 #
 # Clock Generator/Distribution
 #
+# CONFIG_AD9523 is not set
 
 #
 # Phase-Locked Loop (PLL) frequency synthesizers
 #
+# CONFIG_ADF4350 is not set
 
 #
 # Digital gyroscope sensors
 #
+# CONFIG_ADIS16080 is not set
+# CONFIG_ADIS16130 is not set
+# CONFIG_ADIS16136 is not set
+# CONFIG_ADIS16260 is not set
+# CONFIG_ADXRS450 is not set
 CONFIG_HID_SENSOR_GYRO_3D=m
 CONFIG_IIO_ST_GYRO_3AXIS=m
 CONFIG_IIO_ST_GYRO_I2C_3AXIS=m
+CONFIG_IIO_ST_GYRO_SPI_3AXIS=m
 CONFIG_ITG3200=m
 
 #
 # Inertial measurement units
 #
+# CONFIG_ADIS16400 is not set
+# CONFIG_ADIS16480 is not set
 CONFIG_INV_MPU6050_IIO=m
 
 #
@@ -4681,11 +4875,12 @@ CONFIG_VCNL4000=m
 #
 # Magnetometer sensors
 #
-# CONFIG_AK8975 is not set
+CONFIG_AK8975=m
 CONFIG_MAG3110=m
 CONFIG_HID_SENSOR_MAGNETOMETER_3D=m
 CONFIG_IIO_ST_MAGN_3AXIS=m
 CONFIG_IIO_ST_MAGN_I2C_3AXIS=m
+CONFIG_IIO_ST_MAGN_SPI_3AXIS=m
 
 #
 # Triggers - standalone
@@ -4698,6 +4893,7 @@ CONFIG_IIO_SYSFS_TRIGGER=m
 #
 CONFIG_IIO_ST_PRESS=m
 CONFIG_IIO_ST_PRESS_I2C=m
+CONFIG_IIO_ST_PRESS_SPI=m
 
 #
 # Temperature sensors
-- 
1.7.10.4