From f87568b4ea7f53c312dcc9ec9dfc4dfb6278c914 Mon Sep 17 00:00:00 2001
From: Dirk Mueller <dmueller@suse.com>
Date: Thu, 10 Jan 2013 17:57:41 +0100
Subject: [PATCH] Reenable ARMv5 config

---
 config.conf               |   2 +-
 config/armv5tel/versatile | 145 ++++++++++++++++++++++++++++------------------
 2 files changed, 91 insertions(+), 56 deletions(-)

diff --git a/config.conf b/config.conf
index ffc767d..e1ff7dd 100644
--- a/config.conf
+++ b/config.conf
@@ -38,7 +38,7 @@
 +ppc64		ppc64/vanilla
 
 # ARM architectures
-#+armv5tel	armv5tel/versatile
++armv5tel	armv5tel/versatile
 #+armv7hl	armv7hl/default
 #+armv7hl	armv7hl/imx51
 #+armv7hl	armv7hl/omap2plus
diff --git a/config/armv5tel/versatile b/config/armv5tel/versatile
index a7ccc2d..7c62dd1 100644
--- a/config/armv5tel/versatile
+++ b/config/armv5tel/versatile
@@ -1,6 +1,6 @@
 #
 # Automatically generated file; DO NOT EDIT.
-# Linux/arm 3.7.0 Kernel Configuration
+# Linux/arm 3.8.0-rc2 Kernel Configuration
 #
 CONFIG_ARM=y
 CONFIG_MIGHT_HAVE_PCI=y
@@ -25,6 +25,7 @@ CONFIG_SPLIT_PACKAGE=y
 CONFIG_DEFCONFIG_LIST="/lib/modules/$UNAME_RELEASE/.config"
 CONFIG_HAVE_IRQ_WORK=y
 CONFIG_IRQ_WORK=y
+CONFIG_BUILDTIME_EXTABLE_SORT=y
 
 #
 # General setup
@@ -184,10 +185,11 @@ CONFIG_HAVE_CLK=y
 CONFIG_HAVE_DMA_API_DEBUG=y
 CONFIG_HAVE_ARCH_JUMP_LABEL=y
 CONFIG_ARCH_WANT_IPC_PARSE_VERSION=y
-CONFIG_GENERIC_KERNEL_THREAD=y
-CONFIG_GENERIC_KERNEL_EXECVE=y
+CONFIG_HAVE_ARCH_SECCOMP_FILTER=y
+CONFIG_SECCOMP_FILTER=y
 CONFIG_HAVE_MOD_ARCH_SPECIFIC=y
 CONFIG_MODULES_USE_ELF_REL=y
+CONFIG_CLONE_BACKWARDS=y
 
 #
 # GCOV-based kernel profiling
@@ -269,7 +271,6 @@ CONFIG_ARCH_VERSATILE=y
 # CONFIG_ARCH_EBSA110 is not set
 # CONFIG_ARCH_EP93XX is not set
 # CONFIG_ARCH_FOOTBRIDGE is not set
-# CONFIG_ARCH_MXC is not set
 # CONFIG_ARCH_MXS is not set
 # CONFIG_ARCH_NETX is not set
 # CONFIG_ARCH_H720X is not set
@@ -304,8 +305,7 @@ CONFIG_ARCH_VERSATILE=y
 # CONFIG_PLAT_SPEAR is not set
 # CONFIG_ARCH_DAVINCI is not set
 # CONFIG_ARCH_OMAP is not set
-# CONFIG_ARCH_VT8500 is not set
-# CONFIG_ARCH_ZYNQ is not set
+# CONFIG_ARCH_VT8500_SINGLE is not set
 CONFIG_GPIO_PCA953X=m
 CONFIG_KEYBOARD_GPIO_POLLED=m
 
@@ -317,10 +317,9 @@ CONFIG_MACH_VERSATILE_AB=y
 CONFIG_MACH_VERSATILE_DT=y
 CONFIG_PLAT_VERSATILE_CLOCK=y
 CONFIG_PLAT_VERSATILE_CLCD=y
-CONFIG_PLAT_VERSATILE_FPGA_IRQ=y
-CONFIG_PLAT_VERSATILE_FPGA_IRQ_NR=4
 CONFIG_PLAT_VERSATILE_LEDS=y
 CONFIG_PLAT_VERSATILE_SCHED_CLOCK=y
+# CONFIG_ARCH_VT8500 is not set
 CONFIG_PLAT_VERSATILE=y
 CONFIG_ARM_TIMER_SP804=y
 
@@ -396,6 +395,7 @@ CONFIG_FLAT_NODE_MEM_MAP=y
 CONFIG_HAVE_MEMBLOCK=y
 CONFIG_PAGEFLAGS_EXTENDED=y
 CONFIG_SPLIT_PTLOCK_CPUS=999999
+# CONFIG_BALLOON_COMPACTION is not set
 CONFIG_COMPACTION=y
 CONFIG_MIGRATION=y
 # CONFIG_PHYS_ADDR_T_64BIT is not set
@@ -435,6 +435,7 @@ CONFIG_AUTO_ZRELADDR=y
 # CPU Power Management
 #
 CONFIG_CPU_IDLE=y
+# CONFIG_CPU_IDLE_MULTIPLE_DRIVERS is not set
 CONFIG_CPU_IDLE_GOV_LADDER=y
 CONFIG_CPU_IDLE_GOV_MENU=y
 # CONFIG_ARCH_NEEDS_CPU_IDLE_COUPLED is not set
@@ -845,9 +846,11 @@ CONFIG_IP_SCTP=m
 CONFIG_NET_SCTPPROBE=m
 # CONFIG_SCTP_DBG_MSG is not set
 # CONFIG_SCTP_DBG_OBJCNT is not set
-# CONFIG_SCTP_HMAC_NONE is not set
-# CONFIG_SCTP_HMAC_SHA1 is not set
-CONFIG_SCTP_HMAC_MD5=y
+CONFIG_SCTP_DEFAULT_COOKIE_HMAC_MD5=y
+# CONFIG_SCTP_DEFAULT_COOKIE_HMAC_SHA1 is not set
+# CONFIG_SCTP_DEFAULT_COOKIE_HMAC_NONE is not set
+CONFIG_SCTP_COOKIE_HMAC_MD5=y
+# CONFIG_SCTP_COOKIE_HMAC_SHA1 is not set
 CONFIG_RDS=m
 CONFIG_RDS_RDMA=m
 CONFIG_RDS_TCP=m
@@ -869,6 +872,7 @@ CONFIG_STP=m
 CONFIG_GARP=m
 CONFIG_BRIDGE=m
 CONFIG_BRIDGE_IGMP_SNOOPING=y
+CONFIG_HAVE_NET_DSA=y
 CONFIG_NET_DSA=y
 CONFIG_NET_DSA_TAG_DSA=y
 CONFIG_NET_DSA_TAG_EDSA=y
@@ -962,6 +966,7 @@ CONFIG_DCB=y
 CONFIG_DNS_RESOLVER=y
 CONFIG_BATMAN_ADV=m
 # CONFIG_BATMAN_ADV_BLA is not set
+# CONFIG_BATMAN_ADV_DAT is not set
 CONFIG_BATMAN_ADV_DEBUG=y
 CONFIG_OPENVSWITCH=m
 CONFIG_NETPRIO_CGROUP=m
@@ -1008,9 +1013,11 @@ CONFIG_CAN_SLCAN=m
 CONFIG_CAN_DEV=m
 CONFIG_CAN_CALC_BITTIMING=y
 CONFIG_PCH_CAN=m
+# CONFIG_CAN_GRCAN is not set
 CONFIG_CAN_SJA1000=m
 CONFIG_CAN_SJA1000_ISA=m
 CONFIG_CAN_SJA1000_PLATFORM=m
+# CONFIG_CAN_SJA1000_OF_PLATFORM is not set
 CONFIG_CAN_EMS_PCI=m
 # CONFIG_CAN_PEAK_PCI is not set
 CONFIG_CAN_KVASER_PCI=m
@@ -1027,6 +1034,7 @@ CONFIG_CAN_CC770_PLATFORM=m
 #
 CONFIG_CAN_EMS_USB=m
 # CONFIG_CAN_ESD_USB2 is not set
+CONFIG_CAN_KVASER_USB=m
 CONFIG_CAN_PEAK_USB=m
 CONFIG_CAN_SOFTING=m
 # CONFIG_CAN_DEBUG_DEVICES is not set
@@ -1128,7 +1136,7 @@ CONFIG_CFG80211_DEFAULT_PS=y
 # CONFIG_CFG80211_DEBUGFS is not set
 # CONFIG_CFG80211_INTERNAL_REGDB is not set
 CONFIG_CFG80211_WEXT=y
-CONFIG_LIB80211=y
+CONFIG_LIB80211=m
 CONFIG_LIB80211_CRYPT_WEP=m
 CONFIG_LIB80211_CRYPT_CCMP=m
 CONFIG_LIB80211_CRYPT_TKIP=m
@@ -1203,7 +1211,6 @@ CONFIG_DMA_SHARED_BUFFER=y
 #
 # Bus devices
 #
-# CONFIG_OMAP_OCP2SCP is not set
 CONFIG_CONNECTOR=y
 CONFIG_PROC_EVENTS=y
 CONFIG_MTD=m
@@ -1316,7 +1323,8 @@ CONFIG_MTD_NAND_ECC_BCH=y
 CONFIG_MTD_SM_COMMON=m
 CONFIG_MTD_NAND_MUSEUM_IDS=y
 CONFIG_MTD_NAND_DENALI=m
-CONFIG_MTD_NAND_DENALI_SCRATCH_REG_ADDR=0xFF108018
+# CONFIG_MTD_NAND_DENALI_PCI is not set
+# CONFIG_MTD_NAND_DENALI_DT is not set
 CONFIG_MTD_NAND_GPIO=m
 CONFIG_MTD_NAND_IDS=m
 CONFIG_MTD_NAND_RICOH=m
@@ -1572,6 +1580,7 @@ CONFIG_MEGARAID_LEGACY=m
 CONFIG_SCSI_MPT2SAS=m
 CONFIG_SCSI_MPT2SAS_MAX_SGE=128
 # CONFIG_SCSI_MPT2SAS_LOGGING is not set
+# CONFIG_SCSI_MPT3SAS is not set
 CONFIG_SCSI_UFSHCD=m
 CONFIG_SCSI_HPTIOP=m
 CONFIG_LIBFC=m
@@ -1610,6 +1619,7 @@ CONFIG_SCSI_PM8001=m
 CONFIG_SCSI_SRP=m
 CONFIG_SCSI_BFA_FC=m
 CONFIG_SCSI_VIRTIO=m
+# CONFIG_SCSI_CHELSIO_FCOE is not set
 CONFIG_SCSI_DH=m
 CONFIG_SCSI_DH_RDAC=m
 CONFIG_SCSI_DH_HP_SW=m
@@ -1877,6 +1887,9 @@ CONFIG_ATL2=m
 CONFIG_ATL1=m
 CONFIG_ATL1E=m
 CONFIG_ATL1C=m
+CONFIG_NET_CADENCE=y
+CONFIG_ARM_AT91_ETHER=m
+CONFIG_MACB=m
 CONFIG_NET_VENDOR_BROADCOM=y
 CONFIG_B44=m
 CONFIG_B44_PCI_AUTOSELECT=y
@@ -1937,17 +1950,16 @@ CONFIG_E100=m
 CONFIG_E1000=m
 CONFIG_E1000E=m
 CONFIG_IGB=m
-CONFIG_IGB_PTP=y
 CONFIG_IGBVF=m
 CONFIG_IXGB=m
 CONFIG_IXGBE=m
 CONFIG_IXGBE_HWMON=y
 CONFIG_IXGBE_DCB=y
-# CONFIG_IXGBE_PTP is not set
 CONFIG_NET_VENDOR_I825XX=y
 CONFIG_IP1000=m
 CONFIG_JME=m
 CONFIG_NET_VENDOR_MARVELL=y
+# CONFIG_MVMDIO is not set
 CONFIG_SKGE=m
 # CONFIG_SKGE_DEBUG is not set
 CONFIG_SKGE_GENESIS=y
@@ -1975,7 +1987,6 @@ CONFIG_NET_VENDOR_NVIDIA=y
 CONFIG_FORCEDETH=m
 CONFIG_NET_VENDOR_OKI=y
 CONFIG_PCH_GBE=m
-# CONFIG_PCH_PTP is not set
 CONFIG_ETHOC=m
 # CONFIG_NET_PACKET_ENGINE is not set
 CONFIG_NET_VENDOR_QLOGIC=y
@@ -2003,7 +2014,6 @@ CONFIG_SIS190=m
 CONFIG_SFC=m
 CONFIG_SFC_MTD=y
 CONFIG_SFC_MCDI_MON=y
-CONFIG_SFC_PTP=y
 CONFIG_NET_VENDOR_SMSC=y
 CONFIG_SMC91X=m
 CONFIG_EPIC100=m
@@ -2098,6 +2108,7 @@ CONFIG_USB_NET_AX8817X=m
 CONFIG_USB_NET_CDCETHER=m
 CONFIG_USB_NET_CDC_EEM=m
 CONFIG_USB_NET_CDC_NCM=m
+# CONFIG_USB_NET_CDC_MBIM is not set
 CONFIG_USB_NET_DM9601=m
 CONFIG_USB_NET_SMSC75XX=m
 CONFIG_USB_NET_SMSC95XX=m
@@ -2139,33 +2150,13 @@ CONFIG_RTL8187_LEDS=y
 CONFIG_ADM8211=m
 CONFIG_MAC80211_HWSIM=m
 CONFIG_MWL8K=m
-CONFIG_ATH_COMMON=m
-# CONFIG_ATH_DEBUG is not set
-CONFIG_ATH5K=m
-# CONFIG_ATH5K_DEBUG is not set
-# CONFIG_ATH5K_TRACER is not set
-CONFIG_ATH5K_PCI=y
-CONFIG_ATH9K_HW=m
-CONFIG_ATH9K_COMMON=m
-CONFIG_ATH9K_BTCOEX_SUPPORT=y
-CONFIG_ATH9K=m
-CONFIG_ATH9K_PCI=y
-# CONFIG_ATH9K_AHB is not set
-# CONFIG_ATH9K_DEBUGFS is not set
-CONFIG_ATH9K_RATE_CONTROL=y
-CONFIG_ATH9K_HTC=m
-# CONFIG_ATH9K_HTC_DEBUGFS is not set
-CONFIG_CARL9170=m
-CONFIG_CARL9170_LEDS=y
-# CONFIG_CARL9170_DEBUGFS is not set
-CONFIG_CARL9170_WPC=y
-# CONFIG_CARL9170_HWRNG is not set
-# CONFIG_ATH6KL is not set
+# CONFIG_ATH_CARDS is not set
 # CONFIG_B43 is not set
 # CONFIG_B43LEGACY is not set
 CONFIG_BRCMUTIL=m
 CONFIG_BRCMSMAC=m
 # CONFIG_BRCMFMAC is not set
+# CONFIG_BRCM_TRACING is not set
 # CONFIG_BRCMDBG is not set
 CONFIG_HOSTAP=m
 CONFIG_HOSTAP_FIRMWARE=y
@@ -2237,6 +2228,7 @@ CONFIG_RT2X00_LIB_LEDS=y
 CONFIG_RTL8192CE=m
 CONFIG_RTL8192SE=m
 CONFIG_RTL8192DE=m
+# CONFIG_RTL8723AE is not set
 CONFIG_RTL8192CU=m
 CONFIG_RTLWIFI=m
 CONFIG_RTLWIFI_DEBUG=y
@@ -2451,7 +2443,6 @@ CONFIG_KEYBOARD_OPENCORES=m
 CONFIG_KEYBOARD_SAMSUNG=m
 # CONFIG_KEYBOARD_STOWAWAY is not set
 CONFIG_KEYBOARD_SUNKBD=m
-CONFIG_KEYBOARD_OMAP4=m
 CONFIG_KEYBOARD_XTKBD=m
 CONFIG_INPUT_MOUSE=y
 CONFIG_MOUSE_PS2=y
@@ -2585,6 +2576,7 @@ CONFIG_INPUT_YEALINK=m
 CONFIG_INPUT_CM109=m
 CONFIG_INPUT_UINPUT=m
 CONFIG_INPUT_PCF8574=m
+# CONFIG_INPUT_PWM_BEEPER is not set
 CONFIG_INPUT_GPIO_ROTARY_ENCODER=m
 CONFIG_INPUT_ADXL34X=m
 CONFIG_INPUT_ADXL34X_I2C=m
@@ -2603,6 +2595,7 @@ CONFIG_SERIO_LIBPS2=y
 CONFIG_SERIO_RAW=m
 CONFIG_SERIO_ALTERA_PS2=m
 CONFIG_SERIO_PS2MULT=m
+# CONFIG_SERIO_ARC_PS2 is not set
 CONFIG_GAMEPORT=m
 CONFIG_GAMEPORT_NS558=m
 CONFIG_GAMEPORT_L4=m
@@ -2671,6 +2664,7 @@ CONFIG_SERIAL_ALTERA_UART_MAXPORTS=4
 CONFIG_SERIAL_ALTERA_UART_BAUDRATE=115200
 CONFIG_SERIAL_PCH_UART=m
 CONFIG_SERIAL_XILINX_PS_UART=m
+# CONFIG_SERIAL_ARC is not set
 CONFIG_PRINTER=m
 # CONFIG_LP_CONSOLE is not set
 CONFIG_PPDEV=m
@@ -2740,6 +2734,7 @@ CONFIG_I2C_ALGOBIT=m
 #
 # I2C system bus drivers (mostly embedded / system-on-chip)
 #
+CONFIG_I2C_CBUS_GPIO=m
 # CONFIG_I2C_DESIGNWARE_PLATFORM is not set
 # CONFIG_I2C_DESIGNWARE_PCI is not set
 # CONFIG_I2C_EG20T is not set
@@ -2798,7 +2793,7 @@ CONFIG_PTP_1588_CLOCK=m
 #
 # Enable PHYLIB and NETWORK_PHY_TIMESTAMPING to see the additional clocks.
 #
-# CONFIG_PTP_1588_CLOCK_PCH is not set
+CONFIG_PTP_1588_CLOCK_PCH=m
 CONFIG_ARCH_HAVE_CUSTOM_GPIO_H=y
 CONFIG_ARCH_WANT_OPTIONAL_GPIOLIB=y
 CONFIG_GPIOLIB=y
@@ -2814,6 +2809,7 @@ CONFIG_GPIO_MAX730X=m
 CONFIG_GPIO_GENERIC_PLATFORM=m
 # CONFIG_GPIO_EM is not set
 CONFIG_GPIO_PL061=y
+# CONFIG_GPIO_TS5500 is not set
 CONFIG_GPIO_VX855=m
 
 #
@@ -2848,6 +2844,10 @@ CONFIG_GPIO_UCB1400=y
 #
 # MODULbus GPIO expanders:
 #
+
+#
+# USB GPIO expanders:
+#
 CONFIG_W1=m
 CONFIG_W1_CON=y
 
@@ -2859,7 +2859,6 @@ CONFIG_W1_MASTER_DS2490=m
 CONFIG_W1_MASTER_DS2482=m
 CONFIG_W1_MASTER_DS1WM=m
 CONFIG_W1_MASTER_GPIO=m
-# CONFIG_HDQ_MASTER_OMAP is not set
 
 #
 # 1-wire Slaves
@@ -2896,7 +2895,10 @@ CONFIG_CHARGER_MAX8903=m
 CONFIG_CHARGER_LP8727=m
 CONFIG_CHARGER_GPIO=m
 # CONFIG_CHARGER_MANAGER is not set
+# CONFIG_CHARGER_BQ2415X is not set
 CONFIG_CHARGER_SMB347=m
+CONFIG_POWER_RESET=y
+# CONFIG_POWER_RESET_GPIO is not set
 CONFIG_POWER_AVS=y
 CONFIG_HWMON=y
 CONFIG_HWMON_VID=m
@@ -3014,6 +3016,12 @@ CONFIG_SENSORS_W83627HF=m
 CONFIG_SENSORS_W83627EHF=m
 CONFIG_THERMAL=m
 CONFIG_THERMAL_HWMON=y
+CONFIG_THERMAL_DEFAULT_GOV_STEP_WISE=y
+# CONFIG_THERMAL_DEFAULT_GOV_FAIR_SHARE is not set
+# CONFIG_THERMAL_DEFAULT_GOV_USER_SPACE is not set
+CONFIG_FAIR_SHARE=y
+CONFIG_STEP_WISE=y
+CONFIG_USER_SPACE=y
 CONFIG_WATCHDOG=y
 CONFIG_WATCHDOG_CORE=y
 # CONFIG_WATCHDOG_NOWAYOUT is not set
@@ -3053,6 +3061,7 @@ CONFIG_SSB_SDIOHOST=y
 # CONFIG_SSB_DEBUG is not set
 CONFIG_SSB_DRIVER_PCICORE_POSSIBLE=y
 CONFIG_SSB_DRIVER_PCICORE=y
+# CONFIG_SSB_DRIVER_GPIO is not set
 CONFIG_BCMA_POSSIBLE=y
 
 #
@@ -3062,6 +3071,7 @@ CONFIG_BCMA=m
 CONFIG_BCMA_HOST_PCI_POSSIBLE=y
 CONFIG_BCMA_HOST_PCI=y
 CONFIG_BCMA_DRIVER_GMAC_CMN=y
+# CONFIG_BCMA_DRIVER_GPIO is not set
 # CONFIG_BCMA_DEBUG is not set
 
 #
@@ -3070,7 +3080,9 @@ CONFIG_BCMA_DRIVER_GMAC_CMN=y
 CONFIG_MFD_CORE=y
 CONFIG_MFD_SM501=m
 CONFIG_MFD_SM501_GPIO=y
+# CONFIG_MFD_RTSX_PCI is not set
 CONFIG_MFD_ASIC3=y
+# CONFIG_MFD_TI_AM335X_TSCADC is not set
 CONFIG_HTC_EGPIO=y
 CONFIG_HTC_PASIC3=m
 CONFIG_UCB1400_CORE=m
@@ -3098,6 +3110,8 @@ CONFIG_MFD_RDC321X=m
 CONFIG_MFD_VX855=m
 CONFIG_MFD_WL1273_CORE=m
 # CONFIG_MFD_SYSCON is not set
+# CONFIG_MFD_VIPERBOARD is not set
+# CONFIG_MFD_RETU is not set
 CONFIG_REGULATOR=y
 # CONFIG_REGULATOR_DEBUG is not set
 CONFIG_REGULATOR_DUMMY=y
@@ -3113,8 +3127,10 @@ CONFIG_REGULATOR_MAX1586=m
 CONFIG_REGULATOR_MAX8649=m
 CONFIG_REGULATOR_MAX8660=m
 CONFIG_REGULATOR_MAX8952=m
+CONFIG_REGULATOR_MAX8973=m
 CONFIG_REGULATOR_LP3971=m
 CONFIG_REGULATOR_LP3972=m
+CONFIG_REGULATOR_TPS51632=m
 CONFIG_REGULATOR_TPS6105X=m
 CONFIG_REGULATOR_TPS62360=m
 CONFIG_REGULATOR_TPS65023=m
@@ -3219,7 +3235,13 @@ CONFIG_RADIO_WL128X=m
 #
 CONFIG_DVB_FIREDTV=m
 CONFIG_DVB_FIREDTV_INPUT=y
+CONFIG_MEDIA_COMMON_OPTIONS=y
+
+#
+# common driver options
+#
 CONFIG_SMS_SIANO_MDTV=m
+CONFIG_SMS_SIANO_RC=y
 CONFIG_MEDIA_SUBDRV_AUTOSELECT=y
 
 #
@@ -3508,6 +3530,7 @@ CONFIG_LOGO_LINUX_CLUT224=y
 #
 # Bootsplash configuration
 #
+# CONFIG_FB_SSD1307 is not set
 CONFIG_SOUND=m
 CONFIG_SOUND_OSS_CORE=y
 # CONFIG_SOUND_OSS_CORE_PRECLAIM is not set
@@ -3660,6 +3683,7 @@ CONFIG_SND_FIREWIRE=y
 CONFIG_SND_FIREWIRE_LIB=m
 CONFIG_SND_FIREWIRE_SPEAKERS=m
 CONFIG_SND_ISIGHT=m
+# CONFIG_SND_SCS1X is not set
 # CONFIG_SND_SOC is not set
 CONFIG_SOUND_PRIME=m
 CONFIG_AC97_BUS=m
@@ -3698,6 +3722,7 @@ CONFIG_HID_KYE=m
 CONFIG_HID_UCLOGIC=m
 CONFIG_HID_WALTOP=m
 CONFIG_HID_GYRATION=m
+# CONFIG_HID_ICADE is not set
 CONFIG_HID_TWINHAN=m
 CONFIG_HID_KENSINGTON=m
 CONFIG_HID_LCPOWER=m
@@ -3753,6 +3778,11 @@ CONFIG_HID_ZYDACRON=m
 CONFIG_USB_HID=m
 CONFIG_HID_PID=y
 CONFIG_USB_HIDDEV=y
+
+#
+# I2C HID support
+#
+# CONFIG_I2C_HID is not set
 CONFIG_USB_ARCH_HAS_OHCI=y
 CONFIG_USB_ARCH_HAS_EHCI=y
 CONFIG_USB_ARCH_HAS_XHCI=y
@@ -3784,6 +3814,7 @@ CONFIG_USB_XHCI_HCD=m
 CONFIG_USB_EHCI_HCD=m
 CONFIG_USB_EHCI_ROOT_HUB_TT=y
 CONFIG_USB_EHCI_TT_NEWSCHED=y
+CONFIG_USB_EHCI_PCI=m
 CONFIG_USB_OXU210HP_HCD=m
 CONFIG_USB_ISP116X_HCD=m
 CONFIG_USB_ISP1760_HCD=m
@@ -3791,7 +3822,7 @@ CONFIG_USB_ISP1362_HCD=m
 CONFIG_USB_OHCI_HCD=m
 CONFIG_USB_OHCI_HCD_SSB=y
 CONFIG_USB_OHCI_HCD_PLATFORM=y
-CONFIG_USB_EHCI_HCD_PLATFORM=y
+CONFIG_USB_EHCI_HCD_PLATFORM=m
 # CONFIG_USB_OHCI_BIG_ENDIAN_DESC is not set
 # CONFIG_USB_OHCI_BIG_ENDIAN_MMIO is not set
 CONFIG_USB_OHCI_LITTLE_ENDIAN=y
@@ -3839,7 +3870,6 @@ CONFIG_USB_STORAGE_ONETOUCH=m
 CONFIG_USB_STORAGE_KARMA=m
 CONFIG_USB_STORAGE_CYPRESS_ATACB=m
 CONFIG_USB_STORAGE_ENE_UB6250=m
-CONFIG_USB_UAS=m
 
 #
 # USB Imaging devices
@@ -3938,8 +3968,8 @@ CONFIG_USB_EZUSB_FX2=m
 #
 # USB Physical Layer drivers
 #
-# CONFIG_OMAP_USB2 is not set
 # CONFIG_USB_ISP1301 is not set
+# CONFIG_USB_RCAR_PHY is not set
 CONFIG_USB_ATM=m
 CONFIG_USB_SPEEDTOUCH=m
 CONFIG_USB_CXACRU=m
@@ -3974,7 +4004,6 @@ CONFIG_USB_ETH_RNDIS=y
 # CONFIG_USB_G_NCM is not set
 # CONFIG_USB_GADGETFS is not set
 # CONFIG_USB_FUNCTIONFS is not set
-# CONFIG_USB_FILE_STORAGE is not set
 # CONFIG_USB_MASS_STORAGE is not set
 # CONFIG_USB_GADGET_TARGET is not set
 # CONFIG_USB_G_SERIAL is not set
@@ -4140,6 +4169,7 @@ CONFIG_RTC_DRV_RS5C372=m
 CONFIG_RTC_DRV_ISL1208=m
 CONFIG_RTC_DRV_ISL12022=m
 CONFIG_RTC_DRV_X1205=m
+# CONFIG_RTC_DRV_PCF8523 is not set
 CONFIG_RTC_DRV_PCF8563=m
 CONFIG_RTC_DRV_PCF8583=m
 CONFIG_RTC_DRV_M41T80=m
@@ -4208,6 +4238,7 @@ CONFIG_UIO=m
 CONFIG_UIO_CIF=m
 CONFIG_UIO_PDRV=m
 CONFIG_UIO_PDRV_GENIRQ=m
+# CONFIG_UIO_DMEM_GENIRQ is not set
 CONFIG_UIO_AEC=m
 CONFIG_UIO_SERCOS3=m
 CONFIG_UIO_PCI_GENERIC=m
@@ -4247,7 +4278,6 @@ CONFIG_RTLLIB_CRYPTO_TKIP=m
 CONFIG_RTLLIB_CRYPTO_WEP=m
 CONFIG_RTL8192E=m
 CONFIG_R8712U=m
-# CONFIG_RTS_PSTOR is not set
 # CONFIG_RTS5139 is not set
 CONFIG_TRANZPORT=m
 CONFIG_IDE_PHISON=m
@@ -4304,10 +4334,7 @@ CONFIG_STAGING_MEDIA=y
 # Android
 #
 # CONFIG_ANDROID is not set
-CONFIG_PHONE=m
-CONFIG_PHONE_IXJ=m
 CONFIG_USB_WPAN_HCD=m
-# CONFIG_IPACK_BUS is not set
 # CONFIG_WIMAX_GDM72XX is not set
 CONFIG_CSR_WIFI=m
 CONFIG_NET_VENDOR_SILICOM=y
@@ -4315,6 +4342,8 @@ CONFIG_NET_VENDOR_SILICOM=y
 # CONFIG_BPCTL is not set
 # CONFIG_CED1401 is not set
 # CONFIG_DGRP is not set
+# CONFIG_SB105X is not set
+CONFIG_FIREWIRE_SERIAL=m
 CONFIG_CLKDEV_LOOKUP=y
 CONFIG_HAVE_MACH_CLKDEV=y
 
@@ -4357,6 +4386,9 @@ CONFIG_VMIVME_7805=m
 CONFIG_VME_USER=m
 CONFIG_VME_PIO2=m
 CONFIG_PWM=y
+CONFIG_VERSATILE_FPGA_IRQ=y
+CONFIG_VERSATILE_FPGA_IRQ_NR=4
+# CONFIG_IPACK_BUS is not set
 
 #
 # File systems
@@ -4365,11 +4397,9 @@ CONFIG_PWM=y
 # CONFIG_EXT3_FS is not set
 CONFIG_EXT4_FS=y
 CONFIG_EXT4_USE_FOR_EXT23=y
-CONFIG_EXT4_FS_XATTR=y
 CONFIG_EXT4_FS_POSIX_ACL=y
 CONFIG_EXT4_FS_SECURITY=y
 # CONFIG_EXT4_DEBUG is not set
-CONFIG_EXT4_FS_RICHACL=y
 CONFIG_JBD2=y
 # CONFIG_JBD2_DEBUG is not set
 CONFIG_FS_MBCACHE=y
@@ -4384,7 +4414,6 @@ CONFIG_JFS_POSIX_ACL=y
 CONFIG_JFS_SECURITY=y
 # CONFIG_JFS_DEBUG is not set
 CONFIG_JFS_STATISTICS=y
-CONFIG_FS_RICHACL=y
 CONFIG_XFS_FS=m
 CONFIG_XFS_QUOTA=y
 CONFIG_XFS_POSIX_ACL=y
@@ -4532,6 +4561,10 @@ CONFIG_UFS_FS_WRITE=y
 # CONFIG_UFS_DEBUG is not set
 CONFIG_EXOFS_FS=m
 # CONFIG_EXOFS_DEBUG is not set
+CONFIG_F2FS_FS=m
+CONFIG_F2FS_STAT_FS=y
+CONFIG_F2FS_FS_XATTR=y
+CONFIG_F2FS_FS_POSIX_ACL=y
 CONFIG_ORE=m
 CONFIG_NETWORK_FILESYSTEMS=y
 CONFIG_NFS_FS=m
@@ -4575,7 +4608,7 @@ CONFIG_CIFS_UPCALL=y
 CONFIG_CIFS_XATTR=y
 CONFIG_CIFS_POSIX=y
 CONFIG_CIFS_ACL=y
-# CONFIG_CIFS_DEBUG2 is not set
+# CONFIG_CIFS_DEBUG is not set
 CONFIG_CIFS_DFS_UPCALL=y
 # CONFIG_CIFS_SMB2 is not set
 CONFIG_CIFS_FSCACHE=y
@@ -4900,6 +4933,7 @@ CONFIG_CRYPTO_ARC4=m
 CONFIG_CRYPTO_BLOWFISH=m
 CONFIG_CRYPTO_BLOWFISH_COMMON=m
 CONFIG_CRYPTO_CAMELLIA=m
+CONFIG_CRYPTO_CAST_COMMON=m
 CONFIG_CRYPTO_CAST5=m
 CONFIG_CRYPTO_CAST6=m
 CONFIG_CRYPTO_DES=m
@@ -4940,6 +4974,7 @@ CONFIG_GENERIC_STRNCPY_FROM_USER=y
 CONFIG_GENERIC_STRNLEN_USER=y
 CONFIG_GENERIC_PCI_IOMAP=y
 CONFIG_GENERIC_IO=y
+CONFIG_PERCPU_RWSEM=y
 CONFIG_CRC_CCITT=m
 CONFIG_CRC16=y
 CONFIG_CRC_T10DIF=y
-- 
1.8.0.2