>From 42de8b5dbe3a6842dc37cac811b9ea6c8fae8a01 Mon Sep 17 00:00:00 2001
From: Guillaume GARDET <guillaume.gardet@oliseo.fr>
Date: Wed, 17 Oct 2012 14:31:12 +0200
Subject: [PATCH] Update (ARM) Exynos config.  - Enable useful modules (audio,
 video, wifi, ...)  - Enable compatible boards

---
 config/armv7hl/exynos |  102 +++++++++++++++++++++++++++++++++++--------------
 1 file changed, 73 insertions(+), 29 deletions(-)

diff --git a/config/armv7hl/exynos b/config/armv7hl/exynos
index 6d579fe..6993599 100644
--- a/config/armv7hl/exynos
+++ b/config/armv7hl/exynos
@@ -1,6 +1,6 @@
 #
 # Automatically generated file; DO NOT EDIT.
-# Linux/arm 3.6.0 Kernel Configuration
+# Linux/arm 3.6.2 Kernel Configuration
 #
 CONFIG_ARM=y
 CONFIG_SYS_SUPPORTS_APM_EMULATION=y
@@ -341,33 +341,40 @@ CONFIG_PLAT_S5P=y
 #
 # Boot options
 #
+# CONFIG_S3C_BOOT_WATCHDOG is not set
 # CONFIG_S3C_BOOT_ERROR_RESET is not set
 CONFIG_S3C_BOOT_UART_FORCE_FIFO=y
-CONFIG_S3C_LOWLEVEL_UART_PORT=0
+CONFIG_S3C_LOWLEVEL_UART_PORT=2
+CONFIG_S5P_HRT=y
 CONFIG_SAMSUNG_CLOCK=y
 CONFIG_SAMSUNG_CLKSRC=y
 CONFIG_S5P_CLOCK=y
 CONFIG_SAMSUNG_IRQ_VIC_TIMER=y
 CONFIG_S5P_IRQ=y
+CONFIG_S5P_GPIO_INT=y
 CONFIG_SAMSUNG_GPIOLIB_4BIT=y
 CONFIG_S5P_GPIO_DRVSTR=y
 CONFIG_SAMSUNG_GPIO_EXTRA=0
 CONFIG_S3C_GPIO_SPACE=0
 CONFIG_S3C_GPIO_TRACK=y
-# CONFIG_S3C_ADC is not set
+CONFIG_S3C_ADC=y
 CONFIG_S3C_DEV_HSMMC=y
 CONFIG_S3C_DEV_HSMMC1=y
 CONFIG_S3C_DEV_HSMMC2=y
 CONFIG_S3C_DEV_HSMMC3=y
 CONFIG_S3C_DEV_I2C1=y
 CONFIG_S3C_DEV_I2C3=y
+CONFIG_S3C_DEV_I2C5=y
+CONFIG_S3C_DEV_I2C6=y
 CONFIG_S3C_DEV_I2C7=y
 CONFIG_S3C_DEV_USB_HSOTG=y
 CONFIG_S3C_DEV_WDT=y
 CONFIG_S3C_DEV_RTC=y
+CONFIG_SAMSUNG_DEV_ADC=y
 CONFIG_SAMSUNG_DEV_KEYPAD=y
 CONFIG_SAMSUNG_DEV_PWM=y
 CONFIG_SAMSUNG_DEV_BACKLIGHT=y
+CONFIG_S5P_DEV_CSIS0=y
 CONFIG_S5P_DEV_FIMC0=y
 CONFIG_S5P_DEV_FIMC1=y
 CONFIG_S5P_DEV_FIMC2=y
@@ -377,9 +384,11 @@ CONFIG_S5P_DEV_G2D=y
 CONFIG_S5P_DEV_I2C_HDMIPHY=y
 CONFIG_S5P_DEV_JPEG=y
 CONFIG_S5P_DEV_MFC=y
+CONFIG_S5P_DEV_ONENAND=y
 CONFIG_S5P_DEV_TV=y
 CONFIG_S5P_DEV_USB_EHCI=y
-# CONFIG_S3C24XX_PWM is not set
+CONFIG_S3C24XX_PWM=y
+CONFIG_S5P_SETUP_MIPIPHY=y
 CONFIG_SAMSUNG_DMADEV=y
 
 #
@@ -413,10 +422,13 @@ CONFIG_EXYNOS_DEV_SYSMMU=y
 CONFIG_EXYNOS4_DEV_USB_OHCI=y
 CONFIG_EXYNOS4_SETUP_I2C1=y
 CONFIG_EXYNOS4_SETUP_I2C3=y
+CONFIG_EXYNOS4_SETUP_I2C5=y
+CONFIG_EXYNOS4_SETUP_I2C6=y
 CONFIG_EXYNOS4_SETUP_I2C7=y
 CONFIG_EXYNOS4_SETUP_KEYPAD=y
 CONFIG_EXYNOS4_SETUP_SDHCI=y
 CONFIG_EXYNOS4_SETUP_SDHCI_GPIO=y
+CONFIG_EXYNOS4_SETUP_FIMC=y
 CONFIG_EXYNOS4_SETUP_USB_PHY=y
 
 #
@@ -425,8 +437,8 @@ CONFIG_EXYNOS4_SETUP_USB_PHY=y
 CONFIG_MACH_SMDKC210=y
 CONFIG_MACH_SMDKV310=y
 CONFIG_MACH_ARMLEX4210=y
-# CONFIG_MACH_UNIVERSAL_C210 is not set
-# CONFIG_MACH_NURI is not set
+CONFIG_MACH_UNIVERSAL_C210=y
+CONFIG_MACH_NURI=y
 CONFIG_MACH_ORIGEN=y
 
 #
@@ -442,8 +454,8 @@ CONFIG_MACH_SMDK4412=y
 #
 # Flattened Device Tree based board for EXYNOS SoCs
 #
-# CONFIG_MACH_EXYNOS4_DT is not set
-# CONFIG_MACH_EXYNOS5_DT is not set
+CONFIG_MACH_EXYNOS4_DT=y
+CONFIG_MACH_EXYNOS5_DT=y
 
 #
 # Configuration for HSMMC 8-bit bus width
@@ -1897,7 +1909,10 @@ CONFIG_CARL9170_LEDS=y
 # CONFIG_CARL9170_DEBUGFS is not set
 CONFIG_CARL9170_WPC=y
 # CONFIG_CARL9170_HWRNG is not set
-# CONFIG_ATH6KL is not set
+CONFIG_ATH6KL=m
+CONFIG_ATH6KL_SDIO=m
+CONFIG_ATH6KL_USB=m
+CONFIG_ATH6KL_DEBUG=y
 # CONFIG_B43 is not set
 # CONFIG_B43LEGACY is not set
 # CONFIG_BRCMFMAC is not set
@@ -2195,6 +2210,7 @@ CONFIG_TOUCHSCREEN_TOUCHRIGHT=m
 CONFIG_TOUCHSCREEN_TOUCHWIN=m
 CONFIG_TOUCHSCREEN_PIXCIR=m
 CONFIG_TOUCHSCREEN_WM831X=m
+# CONFIG_TOUCHSCREEN_WM97XX is not set
 CONFIG_TOUCHSCREEN_USB_COMPOSITE=m
 # CONFIG_TOUCHSCREEN_MC13783 is not set
 CONFIG_TOUCHSCREEN_USB_EGALAX=y
@@ -2357,7 +2373,7 @@ CONFIG_I2C_NOMADIK=m
 # CONFIG_I2C_PCA_PLATFORM is not set
 # CONFIG_I2C_PXA_PCI is not set
 CONFIG_HAVE_S3C2410_I2C=y
-# CONFIG_I2C_S3C2410 is not set
+CONFIG_I2C_S3C2410=m
 # CONFIG_I2C_SIMTEC is not set
 # CONFIG_I2C_XILINX is not set
 
@@ -2392,7 +2408,7 @@ CONFIG_SPI_LM70_LLP=m
 CONFIG_SPI_OC_TINY=m
 # CONFIG_SPI_PL022 is not set
 # CONFIG_SPI_PXA2XX_PCI is not set
-# CONFIG_SPI_S3C64XX is not set
+CONFIG_SPI_S3C64XX=m
 CONFIG_SPI_XCOMM=m
 # CONFIG_SPI_XILINX is not set
 CONFIG_SPI_DESIGNWARE=y
@@ -2457,6 +2473,7 @@ CONFIG_GPIO_PCF857X=m
 # CONFIG_GPIO_SX150X is not set
 CONFIG_GPIO_STMPE=y
 CONFIG_GPIO_WM831X=m
+# CONFIG_GPIO_WM8994 is not set
 CONFIG_GPIO_ADP5520=m
 CONFIG_GPIO_ADP5588=m
 
@@ -2519,6 +2536,7 @@ CONFIG_BATTERY_BQ27X00_I2C=y
 CONFIG_BATTERY_BQ27X00_PLATFORM=y
 CONFIG_BATTERY_MAX17040=m
 CONFIG_BATTERY_MAX17042=m
+CONFIG_BATTERY_S3C_ADC=m
 CONFIG_CHARGER_ISP1704=m
 CONFIG_CHARGER_MAX8903=m
 CONFIG_CHARGER_LP8727=m
@@ -2539,7 +2557,7 @@ CONFIG_SOFT_WATCHDOG=m
 CONFIG_WM831X_WATCHDOG=m
 # CONFIG_ARM_SP805_WATCHDOG is not set
 CONFIG_HAVE_S3C2410_WATCHDOG=y
-# CONFIG_S3C2410_WATCHDOG is not set
+CONFIG_S3C2410_WATCHDOG=m
 CONFIG_DW_WATCHDOG=m
 CONFIG_MAX63XX_WATCHDOG=m
 
@@ -2575,6 +2593,7 @@ CONFIG_MFD_ASIC3=y
 CONFIG_HTC_EGPIO=y
 # CONFIG_HTC_PASIC3 is not set
 # CONFIG_HTC_I2CPLD is not set
+# CONFIG_UCB1400_CORE is not set
 # CONFIG_MFD_LM3533 is not set
 # CONFIG_TPS6105X is not set
 # CONFIG_TPS65010 is not set
@@ -2618,7 +2637,7 @@ CONFIG_MFD_WM831X=y
 # CONFIG_MFD_WM831X_I2C is not set
 CONFIG_MFD_WM831X_SPI=y
 # CONFIG_MFD_WM8350_I2C is not set
-# CONFIG_MFD_WM8994 is not set
+CONFIG_MFD_WM8994=y
 # CONFIG_MFD_PCF50633 is not set
 CONFIG_MFD_MC13783=m
 CONFIG_MFD_MC13XXX=m
@@ -2658,6 +2677,7 @@ CONFIG_REGULATOR_TPS6507X=m
 CONFIG_REGULATOR_TPS65217=m
 CONFIG_REGULATOR_TPS6524X=m
 CONFIG_REGULATOR_WM831X=m
+# CONFIG_REGULATOR_WM8994 is not set
 CONFIG_MEDIA_SUPPORT=m
 
 #
@@ -3119,7 +3139,7 @@ CONFIG_DRM_I2C_CH7006=m
 CONFIG_DRM_I2C_SIL164=m
 CONFIG_DRM_EXYNOS=m
 CONFIG_DRM_EXYNOS_DMABUF=y
-CONFIG_DRM_EXYNOS_FIMD=y
+# CONFIG_DRM_EXYNOS_FIMD is not set
 CONFIG_DRM_EXYNOS_HDMI=y
 CONFIG_DRM_EXYNOS_VIDI=y
 CONFIG_DRM_EXYNOS_G2D=y
@@ -3163,25 +3183,29 @@ CONFIG_FB_VIRTUAL=m
 CONFIG_FB_METRONOME=m
 CONFIG_FB_BROADSHEET=m
 # CONFIG_FB_AUO_K190X is not set
-# CONFIG_EXYNOS_VIDEO is not set
+CONFIG_EXYNOS_VIDEO=y
+CONFIG_EXYNOS_MIPI_DSI=y
+CONFIG_EXYNOS_LCD_S6E8AX0=y
+CONFIG_EXYNOS_DP=y
 CONFIG_BACKLIGHT_LCD_SUPPORT=y
-CONFIG_LCD_CLASS_DEVICE=m
-# CONFIG_LCD_L4F00242T03 is not set
-# CONFIG_LCD_LMS283GF05 is not set
-# CONFIG_LCD_LTV350QV is not set
-# CONFIG_LCD_TDO24M is not set
-# CONFIG_LCD_VGG2432A4 is not set
-# CONFIG_LCD_PLATFORM is not set
-# CONFIG_LCD_S6E63M0 is not set
-# CONFIG_LCD_LD9040 is not set
+CONFIG_LCD_CLASS_DEVICE=y
+CONFIG_LCD_L4F00242T03=m
+CONFIG_LCD_LMS283GF05=m
+CONFIG_LCD_LTV350QV=m
+CONFIG_LCD_ILI9320=m
+CONFIG_LCD_TDO24M=m
+CONFIG_LCD_VGG2432A4=m
+CONFIG_LCD_PLATFORM=m
+CONFIG_LCD_S6E63M0=m
+CONFIG_LCD_LD9040=m
 CONFIG_LCD_AMS369FG06=m
-CONFIG_BACKLIGHT_CLASS_DEVICE=m
+CONFIG_BACKLIGHT_CLASS_DEVICE=y
 CONFIG_BACKLIGHT_GENERIC=m
 CONFIG_BACKLIGHT_PWM=m
 CONFIG_BACKLIGHT_WM831X=m
 CONFIG_BACKLIGHT_ADP5520=m
-# CONFIG_BACKLIGHT_ADP8860 is not set
-# CONFIG_BACKLIGHT_ADP8870 is not set
+CONFIG_BACKLIGHT_ADP8860=m
+CONFIG_BACKLIGHT_ADP8870=m
 CONFIG_BACKLIGHT_LP855X=m
 
 #
@@ -3218,6 +3242,7 @@ CONFIG_SND_TIMER=m
 CONFIG_SND_PCM=m
 CONFIG_SND_HWDEP=m
 CONFIG_SND_RAWMIDI=m
+CONFIG_SND_JACK=y
 CONFIG_SND_SEQUENCER=m
 CONFIG_SND_SEQ_DUMMY=m
 CONFIG_SND_OSSEMUL=y
@@ -3259,8 +3284,26 @@ CONFIG_SND_USB_UA101=m
 CONFIG_SND_USB_CAIAQ=m
 CONFIG_SND_USB_CAIAQ_INPUT=y
 CONFIG_SND_USB_6FIRE=m
-# CONFIG_SND_SOC is not set
+CONFIG_SND_SOC=m
+CONFIG_SND_SOC_AC97_BUS=y
+# CONFIG_SND_DESIGNWARE_I2S is not set
+CONFIG_SND_SOC_SAMSUNG=m
+CONFIG_SND_SAMSUNG_PCM=m
+CONFIG_SND_SAMSUNG_AC97=m
+CONFIG_SND_SAMSUNG_SPDIF=m
+# CONFIG_SND_SOC_SAMSUNG_SMDK_WM8994 is not set
+CONFIG_SND_SOC_SAMSUNG_SMDK_WM9713=m
+CONFIG_SND_SOC_SAMSUNG_SMDK_SPDIF=m
+CONFIG_SND_SOC_SMDK_WM8994_PCM=m
+CONFIG_SND_SOC_I2C_AND_SPI=m
+# CONFIG_SND_SOC_ALL_CODECS is not set
+CONFIG_SND_SOC_WM_HUBS=m
+CONFIG_SND_SOC_SPDIF=m
+CONFIG_SND_SOC_WM8994=m
+CONFIG_SND_SOC_WM9713=m
+CONFIG_SND_SIMPLE_CARD=m
 CONFIG_SOUND_PRIME=m
+CONFIG_AC97_BUS=m
 
 #
 # HID support
@@ -3845,6 +3888,7 @@ CONFIG_CLKDEV_LOOKUP=y
 #
 # Hardware Spinlock drivers
 #
+CONFIG_CLKSRC_MMIO=y
 CONFIG_IOMMU_API=y
 CONFIG_IOMMU_SUPPORT=y
 CONFIG_OF_IOMMU=y
@@ -3864,7 +3908,7 @@ CONFIG_VIRT_DRIVERS=y
 # CONFIG_MEMORY is not set
 # CONFIG_IIO is not set
 CONFIG_PWM=y
-CONFIG_PWM_SAMSUNG=m
+CONFIG_PWM_SAMSUNG=y
 
 #
 # File systems
-- 
1.7.10.4